! ===========================================================================================================
! integer function qc20_quest_argos_posn.f90
!
! -----------------------------------------------------------------------------------------------------------
!
! Revision history
! date     who    what
! 20170712 all    Release of qcplus v1.1 - many changes to all, some documented/tracked, some not
! 20160511 all    Initial release of qcplus v1.1.0
!
! ===========================================================================================================
! Notes
!
! Function return values:
!  1 = Success, profile passed
! -1 = Failure, profile failed
!  0 = Unable to determine
!

integer function qc20_quest_argos_posn(caller)

use communication                       ! module
use data_arrays                         ! module

implicit none

! ===========================================================================================================
! varialbe/array declarations

character(*), intent( in ) :: caller

character(len=4), parameter :: sub = 'QC20'
character(len=21) ,parameter :: QCTEST='Questinable Argos Position Test'
integer :: result;

integer :: ifl, itype, beg, end;
integer :: ngood,nbad,nskip;

! ===========================================================================================================
! executable statements

ifl = clim_ncol; 

result = NOTD; ! "can not be determined."

if(DBGIO) call dbg_enter(sub)

write(msg,'(a,x,a," is not functional")')sub,QCTEST;
if(DEBUG)then; call wrtdbg(sub,msg); else; call wrttrc(sub,msg); endif
if(DBLEV/=20) return; if(DBLEV==20) return;

! The result returned from evaluate_flags is for the PRIMARY profile (unadjusted field)
qc20_quest_argos_posn = result;
if(DBGIO) call dbg_leave(sub,result);

return
end function qc20_quest_argos_posn
! ===========================================================================================================
