! ===========================================================================================================
!
! program qcplus.f90
!
! ===========================================================================================================
!
! qcplus_version = "v1.1.7 ";
!
! To change qcplus_version, change the avove comment AND ALSO in the character declaration below
!
! This qcplus_version relates only to OPERATIONAL versions - change it when significant changes are instlled
! on /a1  the changes in develop are logged in the Revison history
! ===========================================================================================================
!
! QCPlus overall Revision history
! version  date     who what
! v1.1.7   20191126 VH+ Nearly complete revision of selection of JULD
! v1.1.6   20181017 VH+ Changes to makefile, profile direction, retain qcflag =9
! v1.1.5   20180920 VH+ Changes to allow compile and run on both vargo & nuargo3
! v1.1.4   20180619 VH+ Many changes, consult the README file.
! v1.1.2   20180307 VH+ Creates V3.1 doxy ARGO files (ie, BR nc files)
! v1.1.1   201705nn VH  Creates V3.1 core ARGO files when possible (no DOXY)
! v1.1.0   20160511 all Initial release ncprof UM3.03, ncmeta,nctech UM3.1, nctraj UM3.1 in preparation (QC: 0.0.0)
!
! -----------------------------------------------------------------------------------------------------------
!
! Revision history of qcplus.f90
! date     who    what
! 20200325 VH     Eliminate calls to qca1_climatology and qca2_analysis, Issue FATAL ERROR for APEX_TSB1, bounce floats
! 20191127 VH     Issue a non-fatal error and turn off production of nc files if juld is fill value, and juldqc is NOT.
!                 Eliminate NON-FATAL ERROR 206 if DPLS is not recognized.
! 20191126 VH     Bad gps fix actions moved to other f90s. Add CHOICE line to log, for JULD selection.
!                 If any bad gps fixes were found, and a good JULD is found, correct bad  year/month/day with JULD
! 20190910 VH     Restore fixes lost in a failed installation: Defer running qc22 for profiles jobs (STS/NST
!                 needs implementation) and eliminate it running during the traj job.
! 20190904 VH     Retrieve env var BADGPS to debug BADGPS fix; modify use of posloc when it is zero;
!                 If any bad gps fixes are detected, correct them using the JULD (if it is good)
! 20190708 VH&JN   Initialize two variables used in DPLS that may (on_land_result & speed_result) that may start
!                 out corrupted. Add a setcion to "jump over" creatioh of DPLS if the"newmeta" job is running,
!                 directly defining DPLS as '____" - none could be evaluated.
! 20190521 VH     Adjustments & changes to DBG parameters retrieve from env vars, including additipon of DOGRID
!                 variables to output grids for position_on_land and regional test. Adjustment of some DEB LEV messaging.
! 20190416 VH     Added several new logicals for special debugs; added lines to debug Vertical Sampling Scheme;
!                 adn posloc (position location)
! 20190311 VH&JN  Selection of POSITION (posloc), POSITION_QC now determined in new pick_profile_pos.f90
! 20181127 JN     Took out position qc logic and created a new module - pick_profile_pos.f90
! 20181109 JN     Initialize the six pos_<>qc variables as '0', not'n'
! 20181017 VH     Minor changes for defining the DIRECTION
! 20180724 VH     INTERPOLATION/ICE DETECTION: Analysis of interpolation & ice float information
! 20170702 VH     Transmisison of TESAC files to GTS was terminated, at the request of GTS.
! 20180417 VH     General WARNING revisions.
! 20170312 VH     Use sub direct_exit for problematic exits; 
! 20180320 VH     Fpr DOXY floats, check env var MAKE_NCBIOP - if F or missing, make V3.0 R file, of T make V3.1 R & BR files
! 20180307 VH&all Creates V3.1 doxy ARGO files (ie, BR nc files) and numerous changes (README.20180307...)
! 201710?? VH     Modifications for BR files
! 20171019 VH     Rearrange writeing the report line - WARNINGS/ERORS were not triggering EXIT_STATUS=2.
! 20170721 VH     Check profile_<param>_qc - change 'Z' to blank, nc file value for qc
! 20170718 CA&VH  Restore write statement to add dpls to reportline
! 20170712 all    Release of qcplus v1.1 - many changes to all, some documented/tracked, some not
! 201705nn all    Creates V3.1 core ARGO files when possible (no DOXY)
! 20160511 all    Initial release ncprof UM3.03, ncmeta,nctech UM3.1, nctraj UM3.1 in preparation (QC: 0.0.0)
!
! ===========================================================================================================
! User's Manuals:
!
! UM3.2  = ARGO USER'S MANUAL Version 3.2  2,151228 *December 29th, 2015) - used for all non-day floats
! UM3.1  = ARGO USER'S MANUAL Version 3.1  20141107 (November 7th, 2014)  - supersceded by v3.2
! UM3.03 = ARGO USER'S MANUAL Version 3.03 20130828 (August 28th 2013)    - used for doxy floats ungil biop ready
!
! Variables associated with the differences between format versions are defined at the end of the data_arrays.f90
! module declarations (before the "contains" statement. The section starts with "FORMAT_VERSION variables"
!
! QC Manual
! Argo Quality Control Manual Version 2.9.1 20141118 (18 November 2014)
! 
! ===========================================================================================================
! 
! ===========================================================================================================
! Notes:
!
! Required input parameter
!
! qcplus.x <profile>
!
! Required env variables:
!
! 
! ===========================================================================================================

program qcplus

! ===========================================================================================================

use communication                       ! module
use data_arrays                         ! module

implicit none

! ===========================================================================================================
! varialbe/array declarations

character(len=7), parameter :: qcplus_version = 'v1.1.7 ';

character(len=20),  parameter ::  prg = 'QC+'

character(len=16)  :: today
character(len=128) :: pathname, logdir
character(len=128) :: pathname_ncprof
character(len=128) :: qcprof, pathname_qcprof, pathname_qcdir, pathname_aomlid_dir, pathname_aomlid_qcprof
character(len=128) :: pathname_ncdir, pathname_top_ncprof, pathname_aomlid_ncdir, pathname_aomlid_ncprof
character(len=128) :: phyfile, pathname_phyfile
character(len=128) :: metafile,pathname_meta,prevfile,pathname_prev	! Input files
character(len=128) :: pathname_ncmeta,pathname_nctraj,pathname_nctech,pathname_ncbiop,pathname_ncbiot
character(len=36)  :: filename_tesac;
! mvd to communications character(len=128) :: pathname_trace		! pathname_error,pathname_report,pathname_forlog moved to c.f90
character(len=128) :: pathname_clim_t,pathname_clim_s,pathname_mask_t,pathname_analysis
character(len=1) :: testch1
character(len=3) :: testch3
character(len=4) :: testch4
character(len=5) :: testch5
character(len=SZC) :: testch
character(len=48) :: msgpis	! message about PI-supplied posnqc
character(len=10) :: date; character(len=8) :: hhmmss
logical :: dirok

character(len=2) :: tsp = "  "; ! two spaces
character(len=1) :: repflag(0:9) = (/"_",".","2","3","4","5","6","7","8","9" /);	! report flags (1,4,9,other)
character(len=1) :: repindc(-1:1) = (/"_",".","1"/);					! report indicator (0=all ok, 1=hit)
character(len=1) :: reppsfl(-1:1) = (/"_",".","4"/);					! report NOTD/PASS/FAIL flag

character(len=36) :: QCTEST	! qc test name, full size
character(len=5)  :: QCN	! qc test name, 4-character
character(len=2048) :: oline	! generic output line
character(len=2048) :: oline1	! generic output line1
character(len=2048) :: oline2	! generic output line2
integer :: ret = 0;		! return value for functons
integer :: add_to_JOB_STATUS = 0; ! dpls only
integer :: wrn_to_JOB_STATUS = 0; ! warnings
integer :: err_to_JOB_STATUS = 0; ! non-fatal errors
integer :: ic,ie		! general index for character arrays
integer :: status	! upon error, status is the "number" of the error (see communication.f90)
logical :: file_exist, only_tesac

integer :: ifl

integer :: read_meta,read_phy,get_pqc,get_all_qc			! functions that load data
integer :: read_configtable,read_sensormodeltable,read_trajtable,read_techtable, read_sensor_params_table  ! Read tables
integer :: prepare_launch_config
character(len=1) :: write_qcprof, result_qcprof	   ! declare the function that write prfile data
character(len=1) :: write_ncprof, result_ncprof	   ! declare the function that writes ncprof, and what happened
character(len=1) :: write_ncmeta, result_ncmeta	   ! declare the function that writes ncmeta, and what happened
character(len=1) :: write_nctraj, result_nctraj	   ! declare the function that writes nctraj, and what happened
character(len=1) :: write_nctech, result_nctech	   ! declare the function that writes nctech, and what happened
character(len=1) :: write_ncbiop, result_ncbiop	   ! declare the function that writes ncbiop, and what happened
character(len=1) :: write_ncbiot, result_ncbiot    ! declare the function that writes ncbiot, and what happened
character(len=1) :: write_tesac,  result_tesac;	   ! declare the function that writes gts/tesac file, and what happened
character(len=1) :: complete2tesac,make2tesac	   ! used to write the "complete flag" in PHY2GTSFMT_TABLE
character(len=1) :: c1				   ! for translating logical variables
character(len=4) :: dpls			   ! 4ch variable for date/posn/land/speed results
! =================================================================================	! QCOLD

! The qc tests
! They are numbered by the test number
! The appear here in the order in which they are performed
!

! MOVED TO DATA_ARRAYS MOD integer :: maxflag, maxdeep	!

					! PARM !p/s! Test
integer :: qc19_deepest_pressure	! P    ! p ! Deepest Pressure Test
integer :: qc01_platform_id		!  n/a ! s ! Platform_Identification
integer :: qc02_impossible_date		!  n/a ! s ! Impossible_Date
integer :: qc03_impossible_location	!  n/a ! s ! Impossible_Location
integer :: qc04_position_on_land	!  n/a ! s ! Position_on_Land
integer :: qc05_impossible_speed	!  n/a ! s ! Impossible_Speed
integer :: qc06_gross_test		! PTSO ! p ! AKA Global Range Test
integer :: qc07_regional_test		!  TS  ! p ! Red Sea, Mediterranean Sea
integer :: qc08_pres_increase		! P    ! p ! Pressure Increasing 
integer :: qc09_spike_test		!  TSO ! p ! Spike Test
!       :: qc10_top_bot_spike		!      ! p ! N/ATop and Bottom Spike Test : removed
integer :: qc11_gradient_test		!  TSO ! p ! Gradient Test
!       :: qc12_digit_rollover		!      ! p ! N/A - done in decoders
integer :: qc13_stuck_value   		!  TSO ! p ! AKA Stuck Value
integer :: qc14_density_inversion	!  TS  ! p ! Density Inversion AKA dengrad - REPORTED IN THE SALINITY FLAGS
integer :: qc15_grey_list		! PTS  ! s ! Grey List - whole profile evaluated
integer :: qc16_jump_check		!  TS  !p/s! Jump check AKA Sensor Drift
!          qc17_visual_qc		!      !   ! N/A - applied later by qc operators
integer :: qc18_frozen_profile		!  TS  !p/s! Frozen profile
integer :: qc20_quest_argos_posn        !      !n/a! N/A - JAMSTEC speed check only for traj data
integer :: qc21_ns_unpumped_ctd  !   S  ! p ! near-surface salinity (STS floats)
integer :: qc22_ns_mixed_air_water      ! P    ! p ! near-surfact SST (NST filoats)
! OLD integer :: qca1_climatology             !  TS  !p/s! Climatology test (AOML use only)
! OLD integer :: qca2_analysis                !  TS  !p/s! Analysis test (AOML use only)

logical :: deep_pres_fail, all_pass_complete, all_pass_incomplete
logical :: primary_fail, pri_pass_sec_fail
real :: rtest				! test value

integer :: on_land_result = -1;         ! Save for report line - initialize to "cannot be determined"
integer :: speed_result  = -1;          ! Save for report line - initialize to "cannot be determined"
integer :: qc19_result = -1;		! Save the deepest pressure test results

!real :: lat, lon			! Used for qc07_regional test
integer :: iyr,imo,idy,ihh,imn,isc, idate(6)
equivalence (idate(1),iyr), (idate(2),imo),(idate(3),idy),(idate(4),ihh),(idate(5),imn),(idate(6),isc)
integer :: tsc, tmn	! TEST 
integer :: tlev		! 2000-db level

integer :: beg,end	! TEST
integer :: ipar
integer :: ireg,iadj	! DBG LEV25 counters
integer :: nt = NTESTS	! shorten debug lines

integer :: oer         ! the number of output error message lines

character(len=SZC) :: tmp	! temporary message

character(len=20) :: cmnt1;	! trans_type part of config_mission_comment
character(len=236) :: cmnt2	! explanation of the config_mission_number

! maximum wait time to send incomplete profiles to GTS
real :: TIME_EXEC2GTSFORMAT;
double precision JULD_EXEC2GTSFORMAT, rightnow_JULD;

logical :: skip_profile_qctests = .false.
logical :: zerlines_Z_failure = .false. ! If true, a 'Z' was found in the profile_<param>_qc grades

real :: abslat, abslon; ! Jury-rig for euler compile

character(len=23) :: poslinebeg;
character(len=80) :: poslineend
character(len=10) :: posn_date

integer :: neo; ! Number of error out

character(len=20) :: str20, lefty; ! Use to left-justify short strings

! ===========================================================================================================
! executable statements

! ===========================================================================================================

WRTFILE = 'QCPLUS'; WRTINDX = 0; ! We are not in any of the write file routines

pathname_report = 'NOT DEFINED';		! in case of error before getting the name

result_qcprof = '?';
result_ncprof = '?';
result_ncbiop = '?';
result_ncmeta = '?';
result_nctraj = '?';
result_ncbiot = '?';
result_nctech = '?';
result_tesac  = '?';

do i=1,MAXPOS
    pos_posnqc(i) = '0';        ! 'full' position qc (pos_posiqc ND pis_posnqc
    pis_posnqc(i) = '0';        ! PI-supplied qc
    pos_posiqc(i) = '0';        ! impossible position
    pos_dateqc(i) = '0';        ! date qc
    pos_onland(i) = '0';        ! position on land
    pos_speedc(i) = '0';        ! speed check
enddo


int_CONFIG_MISSION_NUMBER = 0;  ! Cannot be zero, so I'll know if it has been set correctly
errmsg0 = 'n/a';		! This will be the line printed in the log file
config_mission_type = '??';
config_mission_comment = 'UNKNOWN';

! Initialize on_land logicals
topo_file_checked = .false.;			! We have not checked for the topo file yet
topo_file_exists = .false.;			! Assume the worse

! Get profile name from the commandline
!

call GETARG(1, profinp);	! input profile name
if(len(trim(profinp)) == 0)then
    write(STD,'("FATAL ERROR 408 In QCPLUS profile name NOT ENTERED")');	! In qcplus, profile not entered
    write(STD,'("FATAL ERROR 408 LOG/TRC/ERROR files are not open")');	! In qcplus, profile not entered
    write(STD,'("FATAL ERROR 408 Direct exit, return a status of 4")');	! In qcplus, profile not entered
    call direct_exit(prg,4,'profile name NOT ENTERED'); ! In QCPLUS profile name NOT ENTERED
endif
if(len(trim(profinp)) > MAXPROFCHR)then
    write(STD,'("FATAL ERROR 407 In QCPLUS PROFILE name too long")');	! In qcplus, prof name too large
    write(STD,'("FATAL ERROR 407 profile name: ",A)') trim(profinp);		! In qcplus, prof name too large
    write(STD,'("FATAL ERROR 407 Change MAXPROFCHR in communication.f90")');	! In qcplus, prof name too large
    write(STD,'("FATAL ERROR 407 Change also 1000 format in this program")'); 	! In qcplus, prof name too large
    write(STD,'("FATAL ERROR 407 LOG/TRC/ERROR files are not open  ")');	! In qcplus, prof name too large
    write(STD,'("FATAL ERROR 407 Direct exit, return a status of 4 ")');	! In qcplus, prof name too large
    call direct_exit(prg,4,'PROFILE name too long'); ! In QCPLUS PROFILE name too long
endif
profile = profinp(1:20)  ! store for write statements

write(msg,'(" =-=-=-=-=-= Enter QCPLUS - ",a20,"=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=")')profile; tsbeg=timestampmsg(msg)
write(STD,'(a)') trim(tsbeg);                                                                                         ! In qcplus
tserr = trim(tsbeg); ! In case we need to write stuff to the error file
!
! Have we requested debugs? deb-levels?
! Default values are set in communicaitons module

chr1='F'; call get_default_envvar(prg,'DEBUG',chr1); if(chr1=="T") DEBUG = .true.;         ! default DEBUG=F
chr4='0'; call get_default_envvar(prg,'DBLEV',chr4); read(chr4,*)DBLEV;                    ! default DBLEV=0
chr1='F'; call get_default_envvar(prg,'DBLEVEXIT',chr1); if(chr1=="T") DBLEVEXIT = .true.; ! default DBLEVEXIT=F

if(DBLEV > MAXDBLEV)then
    write(STD,'("FATAL ERROR 406 In QCPLUS DBLEV exceeds MAXDBLEV")');			! In qcplus, DBLEV exceeds MAXDBLEV
    write(STD,'("FATAL ERROR 406 QCPLUS    DBLEV: ",i5)')DBLEV;				! In qcplus, DBLEV exceeds MAXDBLEV
    write(STD,'("FATAL ERROR 406 QCPLUS MAXDBLEV: ",i5)')MAXDBLEV			! In qcplus, DBLEV exceeds MAXDBLEV
    write(STD,'("FATAL ERROR 406 LOG/TRC/ERROR files are not open")');            	! In qcplus, DBLEV exceeds MAXDBLEV
    write(STD,'("FATAL ERROR 406 Direct exit, return an exit status of 4")');     	! In qcplus, DBLEV exceeds MAXDBLEV
    call direct_exit(prg,4,'DBLEV exceeds MAXDBLEV'); ! In QCPLUS DBLEV exceeds MAXDBLEV
endif

if(DEBUG)then
    chr1='F'; call get_default_envvar(prg,'DBGIO', chr1); if(chr1=="T") DBGIO  = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGQCT',chr1); if(chr1=="T") DBGQCT = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGDIR',chr1); if(chr1=="T") DBGDIR = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGFIX',chr1); if(chr1=="T") DBGFIX = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGMCL',chr1); if(chr1=="T") DBGMCL = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGPOS',chr1); if(chr1=="T") DBGPOS = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGSOT',chr1); if(chr1=="T") DBGSOT = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGVSS',chr1); if(chr1=="T") DBGVSS = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DOGRID',chr1); if(chr1=="T") DOGRID = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'BADGPS',chr1); if(chr1=="T") BADGPS = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGSTS',chr1); if(chr1=="T") DBGSTS = .true.; ! default =F
    chr1='F'; call get_default_envvar(prg,'DBGNST',chr1); if(chr1=="T") DBGNST = .true.; ! default =F

    ! DBGPOS can either be defined expolicitly, or inferred by DBLEV
    if(DBLEV>=70 .and. DBLEV<80) DBGPOS = .true.; ! Set DBGPOS to T if DBLEV is in the DBGPOS range (70-79)

    ! if BADGPS is true, then set the DVLEV to 2 - impossible date
    if(BADGPS)then; write(DBG,'("QC+ Note that BADGPS is true, so set DBLEV to 2")'); DBLEV = 2; endif; ! DBG

    if(DBLEV== 4 .or. DBLEV== 7)then ! Only use the grid rqueste for qc04 (on land) and qc07 (regional test)
	chr1='F'; call get_default_envvar(prg,'DOGRID',chr1); if(chr1=="T") DOGRID = .true.; ! default =F
	! if DOGRID is true, retrieve the grid characteristics
	if(DOGRID)then
	    call get_default_envvar(prg,'DBGRID',gridpar);
	    if(len(trim(gridpar)) > 0)then
		read(gridpar,*)gridloc,grinc, grxlonlo, grxlonhi, grylatlo, grylathi ! DBGRID parameter values specified
	    endif
	    write(msg,'("DBG DBGRID parameters: ",a8," inc:",f6.3," lon range: ",2f9.3," lat range: ",2f8.3)') &
			gridloc,grinc, grxlonlo, grxlonhi, grylatlo, grylathi
	    write(DBG,'(a)')trim(msg); ! DBG DOGRID
	endif
    endif
	
endif
if(DBLEV>=70 .and. DBLEV<90) DBGPOS = .true.; ! Set DBGPOS to T if DBLEV is in the DBGPOS range (70-89)

! These are special cases - - use DBLEV to signal two actions

! Set upt the error message to be used BEFORE ALL THE LOG/ERR/TRC files are opened

write(repmsg,'(a,"999  4  FFFFFFFF Program error - reported to STANDARD OUTPUT ONLY")')profile
write(errmsg(1),'("FATAL ERROR 999 Something REALLLY BAD has happened to profile: ",a)')trim(profile)
! Get the name of the report file - then it can be used for any further errors

call get_required_envvar(prg,'report_tabfile',pathname_report); ! Special case, an error is NOT reported by the subroutine

if(len(trim(pathname_report)) == 0)then
    write(STD,'("FATAL ERROR 998 In QCPLUS report name NOT DEFINED in env varx")'); ! In qcplus, report name NOT DEFINED
    write(STD,'("FATAL ERROR 998 LOG/TRC/ERROR files are not open")');              ! In qcplus, report name NOT DEFINED
    write(STD,'("FATAL ERROR 998 Direct exit, return an exit status of 4")');       ! In qcplus, report name NOT DEFINED
    call direct_exit(prg,4,'report name NOT DEFINED'); ! In QCPLUS report name NOT DEFINED
endif

! If any of the REQUIRED env vars are not defined, get_required_envvar will
! exit with an error - if it renurns, the evn var was retrieved correctly
! First, get the name of the log file, and ope it

call get_required_envvar(prg,'forlog_outfile',pathname_forlog);
call get_required_envvar(prg,'trace_outfile',pathname_trace);
call get_required_envvar(prg,'error_outfile',pathname_error);

call get_required_envvar(prg,'ftpgts_tabfile',pathname_ftpgts);
call get_required_envvar(prg,'tesac_tabfile', pathname_2tesac);
if(DEBUG .or. .not.DEBUG)then           ! DO NOT ASK ! This section resets the above output filename for VMH testing
    call get_required_envvar(prg,'LOGFILES_DIR',logdir)     ! where to the log/err/trc/etc files go?
    call get_required_envvar(prg,'TODAY',today);            ! env variable for today/now
    if(index(pathname_forlog,"PROFILE") > 0)then
	write(pathname_forlog,'(a,"/",a,".",a,"_forlog")')trim(logdir),trim(profile),trim(today)
	write(pathname_trace, '(a,"/",a,".",a,"_trace")')trim(logdir),trim(profile),trim(today)
	write(pathname_error, '(a,"/",a,".",a,"_error")')trim(logdir),trim(profile),trim(today)
    elseif(index(pathname_trace,"META") > 0)then
	write(pathname_forlog,'(a,"/meta_",a,".",a,"_forlog")')trim(logdir),trim(profile),trim(today)
	write(pathname_trace, '(a,"/meta_",a,".",a,"_trace")')trim(logdir),trim(profile),trim(today)
	write(pathname_error, '(a,"/meta_",a,".",a,"_error")')trim(logdir),trim(profile),trim(today)
    elseif(index(pathname_trace,"TRAJ") > 0)then
	write(pathname_forlog,'(a,"/traj_",a,".",a,"_forlog")')trim(logdir),trim(profile),trim(today)
	write(pathname_trace, '(a,"/traj_",a,".",a,"_trace")')trim(logdir),trim(profile),trim(today)
	write(pathname_error, '(a,"/traj_",a,".",a,"_error")')trim(logdir),trim(profile),trim(today)
    elseif(index(pathname_trace,"TECH") > 0)then
	write(pathname_forlog,'(a,"/tech_",a,".",a,"_forlog")')trim(logdir),trim(profile),trim(today)
	write(pathname_trace, '(a,"/tech_",a,".",a,"_trace")')trim(logdir),trim(profile),trim(today)
	write(pathname_error, '(a,"/tech_",a,".",a,"_error")')trim(logdir),trim(profile),trim(today)
    endif
endif

log_open=open_new_file(LOG,pathname_forlog,"LOG","forlog");
if(.not. log_open)then
    write(errmsg(1),'("FATAL ERROR 401 opening the forlog file")');
    write(errmsg(2),'("FATAL ERROR 401 file: ",a)') trim(pathname_forlog);
    write(errmsg(3),'("FATAL ERROR 401 desc: forlog")')
    call error_exit(prg,401,3,errmsg); ! qcplus - error opening the forlog file
endif
!
! Open the error and trace files
!
err_open=open_new_file(ERR,pathname_error,"ERR","error");
trc_open=open_new_file(TRC,pathname_trace,"TRC","trace")

! The trace/forlog/error files have been (successfully) opened, set the timestamp

write(msg,'("================================================================================")'); call wrtstd(prg,msg);
write(msg,'("FORLOG: ",a)')trim(pathname_forlog); call wrtstd(prg,msg);
write(msg,'(" TRACE: ",a)')trim(pathname_trace); call wrtstd(prg,msg);
write(msg,'(" ERROR: ",a)')trim(pathname_error); call wrtstd(prg,msg);
write(msg,'("--------------------------------------------------------------------------------")'); call wrtstd(prg,msg);
!
! What output files do we want, and where do we put them
!
! These all default to .true., but can be changed in the ENV VARs
!
ans1="F"; call get_default_envvar(prg,"MAKE_QCPROF",ans1); make_qcprof = .true.; if(ans1=='F') make_qcprof = .false.
ans1="F"; call get_default_envvar(prg,"MAKE_NCPROF",ans1); make_ncprof = .true.; if(ans1=='F') make_ncprof = .false.
ans1="F"; call get_default_envvar(prg,"MAKE_NCMETA",ans1); make_ncmeta = .true.; if(ans1=='F') make_ncmeta = .false.
ans1="F"; call get_default_envvar(prg,"MAKE_NCTECH",ans1); make_nctech = .true.; if(ans1=='F') make_nctech = .false.
ans1="F"; call get_default_envvar(prg,"MAKE_NCTRAJ",ans1); make_nctraj = .true.; if(ans1=='F') make_nctraj = .false.
! OLD ans1="F"; call get_default_envvar(prg,"MAKE_TESAC", ans1); make_tesac  = .true.; if(ans1=='F') make_tesac  = .false.
make_tesac  = .false.; ! OLD - PURGE LATER
! ===========================================================================================================

write(msg,'("QCPROF make_qcprof : ",l1)')make_qcprof; call wrtlog(prg,msg);
write(msg,'("NCPROF make_ncprof : ",l1)')make_ncprof; call wrtlog(prg,msg);
write(msg,'("NCMETA make_ncmeta : ",l1)')make_ncmeta; call wrtlog(prg,msg);
write(msg,'("NCTECH make_nctech : ",l1)')make_nctech; call wrtlog(prg,msg);
write(msg,'("NCTRAJ make_nctraj : ",l1)')make_nctraj; call wrtlog(prg,msg);
write(msg,'("TESAC  make_tesac  : ",l1)')make_tesac;  call wrtlog(prg,msg);

!----------------------------------------------------------------------
! These can be used to test output for lognotes, warnings & errors
!
! aomlid = '9999'; thiscyc = 999; ! LGN TST
! aomlid = '0000'; thiscyc = 500; ! LGN TST
! write(wrnmsg,'("WARNING 100 MESSAGE to TEST LOGNOTE")'); ! LGN TST
! call lognote(prg,100,wrnmsg); ! WARNING 100 LGN TST
!
! aomlid = '9999'; thiscyc = 9999; ! WRN TST
! write(wrnmsg,'("WARNING 100 MESSAGE to TEST WARNING")'); ! WRN TST warning
! call warning(prg,100,wrnmsg); ! WARNING 100 in qcplus TST ! WRN
!
! write(errmsg(1),'("NON-FATAL ERROR 200 in QC+, TEST ERROR - REPORTING Line 1")'); ! ERR TST
! write(errmsg(2),'("NON-FATAL ERROR 200 in QC+, TEST ERROR - REPORTING Line 2")'); ! ERR TST
! call error_report(prg,200,2,errmsg); ! ERR TST
!
! write(errmsg(1),'("FATAL ERROR 400 in QC+, TEST ERROR - EXITING Line 1")'); ! ERR TST
! write(errmsg(2),'("FATAL ERROR 400 in QC+, TEST ERROR - EXITING Line 2")'); ! ERR TST
! call error_exit(prg,400,2,errmsg); ! ERR TST
! 
! write(DBG,'("TEST messaging, EXIT QC+")'); call direct_exit(prg,0,'TEST direct)exit'); ! DBG

! ===========================================================================================================

if(make_qcprof .or. make_ncprof .or. make_tesac)then
    if(make_ncmeta .or. make_nctech .or. make_nctraj)then
	filmsg = 'FFFFFFFF'; 
	write(errmsg(1),'("FATAL ERROR 404 Mix of PROF & NONPROF files requested")')
	write(errmsg(2),'("FATAL ERROR 404 make_qcprof: ",l1," PROF")')make_qcprof;
	write(errmsg(3),'("FATAL ERROR 404 make_ncprof: ",l1," PROF")')make_ncprof;
	write(errmsg(4),'("FATAL ERROR 404 make_ncmeta: ",l1," NONP")')make_ncmeta;
	write(errmsg(5),'("FATAL ERROR 404 make_nctraj: ",l1," NONP")')make_nctraj;
	write(errmsg(6),'("FATAL ERROR 404 make_nctech: ",l1," NONP")')make_nctech;
	write(errmsg(7),'("FATAL ERROR 404 make_tesac : ",l1," PROF")')make_tesac;
	call error_exit(prg,994,7,errmsg); ! ERR
    endif
endif


33 continue

! get the profile informatin from the input filename
if(index(profile,".phy") > 0)then
    profile=trim(profile);
    phyfile = profile;
    profile = profile(1:((len(trim(profile))-4))); ! .phy is present, strip it off
else
    phyfile = trim(profile) // '.phy';
endif
read(profile,'(a4)')aomlid
ic = index(profile,"_",.true.);	! where is LAST "_" rindex= location of LAST occurrance of a string
ie = len(trim(profile));	! length of te profile name
float_name=profile(1:(ic-1));	! strip off the cycle for use to make the meta file name
if(profile(ie:ie) == "D")then;
    phy_descending = .true.;  chr_DIRECTION = "D"; direction_filename = 'D';
    if(DBGDIR) write(DBG,'("DBGDIR read_phy set DIR to ",a," from D in phyfile name")')chr_DIRECTION
    ccyc=profile((ic+1):ie-1);
    if(DEBUG)then; write(msg,'("QC+ ASC/DSC descending phyfile, from the cycle: ",a)')trim(ccyc); call wrtlog(prg,msg); endif
else;
    phy_descending = .false.; chr_DIRECTION = "A"; direction_filename = 'A';
    if(DBGDIR) write(DBG,'("DBGDIR read_phy set DIR to ",a," from NO D in phyfile name")')chr_DIRECTION
    ccyc=profile((ic+1):ie);
    if(DEBUG)then; write(msg,'("QC+ ASC/DSC ascending phyfile, from the cycle: ",a)')trim(ccyc); call wrtlog(prg,msg); endif
endif
if(ccyc(1:3) == "xxx")then
    call wrtflm(prg,'@xxx1 Initial values before assignment');
    write(msg,'("This is an ncmeta run with NO cycles.")'); call wrttrc(prg,msg);
    meta_FORMAT_VERSION = "3.1"; ! NCMETA_FORMAT_VERSION KLUGE
    ncmeta_noprof = .true.;	! It was initialized as .false. in communication
    ccyc = '-1';		! It is used in read_meta, this will have no effect
    if(.not. make_ncmeta)then
	make_ncmeta = .true.;
    endif
    if(make_qcprof) make_qcprof = .false.; ! cycxxx - ncmeta only, no profile present
    if(make_ncprof) make_ncprof = .false.; ! cycxxx - ncmeta only
    if(make_nctraj) make_nctraj = .false.; ! cycxxx - ncmeta only
    if(make_nctech) make_nctech = .false.; ! cycxxx - ncmeta only
    if(make_tesac)  make_tesac = .false.;  ! cycxxx - ncmeta only

    call wrtflm(prg,'@xxx2 Initial values after  assignment');

endif

read(ccyc,*) thiscyc;

!
! Compose the meta file name 
!
metafile = trim(float_name) // ".meta"
call get_required_envvar(prg,'METAFILES_DIR',pathname_metadir)
pathname_meta = trim(pathname_metadir) // trim(metafile)

!
! Read the meta file and stash what you will need
!
chr_POSITIONING_SYSTEM = 'UNKNOWN ';
POSITIONING_SYSTEM_from = 'POSITIONING_SYSTEM FROM                 UNKNOWN'
if(DBLEV==49)then; write(msg,'("QC+ @1 Set chr_POSITIONING_SYSTEM=UNKNOWN")'); call wrtdbg(prg,msg); endif
ret=read_meta(pathname_meta)
if(DEBUG .and. DBLEV==47)then	! meta file info								! DBG LEV43
    write(msg,'("========== meta file information ==========")');			call wrtdbg(prg,msg);   ! DBG LEV43
    write(msg,'("              WMOID: ",a)')trim(wmoid);				call wrtdbg(prg,msg);	! DBG LEV43
    write(msg,'("        send_to_GTS: ",i2," (BEFORE checking date)")')send_to_GTS;	call wrtdbg(prg,msg);	! DBG LEV43
    write(msg,'("   add_to_grey_list: ",i2)')add_to_grey_list;				call wrtdbg(prg,msg);	! DBG LEV43
    write(msg,'("        do_psal_adj: ",i2)')do_psal_adj;				call wrtdbg(prg,msg);	! DBG LEV43
    write(msg,'(" nominal_prof_pres i ",f8.1)') nominal_prof_pres;			call wrtdbg(prg,msg);	! DBG LEV43
    write(msg,'(" nominal_prof_ncyc1: ",i8  )') nominal_prof_ncyc1;			call wrtdbg(prg,msg);   ! DBG LEV43
    write(msg,'(" nominal_prof_pres1: ",f8.1)') nominal_prof_pres1;			call wrtdbg(prg,msg);   ! DBG LEV43
    write(msg,'(" nominal_prof_ncyc2: ",i8  )') nominal_prof_ncyc2;			call wrtdbg(prg,msg);   ! DBG LEV43
    write(msg,'(" nominal_prof_pres2: ",f8.1)') nominal_prof_pres2;			call wrtdbg(prg,msg);   ! DBG LEV43
    if(nominal_prof_ncyc2 > 0)then;										! DBG LEV43
	write(msg,'(" nominal_prof_ncyc1: ",i8  )') nominal_prof_ncyc1;			call wrtdbg(prg,msg);   ! DBG LEV43
	write(msg,'(" nominal_prof_pres2: ",f8.1)') nominal_prof_pres2; 		call wrtdbg(prg,msg);   ! DBG LEV43
    else													! DBG LEV43
	write(msg,'(" nominal_prof_pres2: FILL")');								! DBG LEV43
    endif													! DBG LEV43
    if(ngl == 0)then												! DBG LEV43
	write(msg,'(" There are NO grey list entries")');				call wrtdbg(prg,msg);	! DBG LEV43
    else													! DBG LEV43
	write(msg,'(" There are ",i2," grey list entries")')ngl;			call wrtdbg(prg,msg);	! DBG LEV43
	do igl=1,ngl												! DBG LEV43
	    write(msg,*)'LEV43   ',igl,' begend: ',grey_list_beg(igl),' ',grey_list_end(igl), &			! DBG LEV43
		(param_on_grey_list(igl,igp),igp=1,MAX_GL_PARAM), &						! DBG LEV43
		(grey_flag(igl,igp),igp=1,MAX_GL_PARAM);							! DBG LEV43
	    call wrtdbg(prg,msg);										! DBG LEV43
	enddo													! DBG LEV43
    endif													! DBG LEV43
    if(npa == 0)then												! DBG LEV43
	write(msg,'(" There are NO psal_adj entries")');				call wrtdbg(prg,msg);	! DBG LEV43
    else													! DBG LEV43
	write(msg,'(" Number of psal entries: ",i2)')npa;				call wrtdbg(prg,msg);	! DBG LEV43
	do ipa=1,npa												! DBG LEV43
	    write(msg,*)'LEV43 PA  ',ipa,' line: ',trim(psal_adj_line(ipa)); call wrtdbg(prg,msg);		! DBG LEV43
	enddo													! DBG LEV43
	write(msg,*)'LEV43 psal_adj uses: ',psal_adj_dd, psal_adj_mm,psal_adj_yr,psal_adj_cyc, &		! DBG LEV43
		    psal_offset,psal_stddev									! DBG LEV43
    endif													! DBG LEV43
elseif(DEBUG .and. DBLEV==19) then
    write(msg,'(" nominal_prof_pres i ",f8.1)') nominal_prof_pres;                      call wrtdbg(prg,msg);   ! DBG LEV19
    write(msg,'(" nominal_prof_ncyc1: ",i8  )') nominal_prof_ncyc1;                     call wrtdbg(prg,msg);   ! DBG LEV19
    write(msg,'(" nominal_prof_pres1: ",f8.1)') nominal_prof_pres1;                     call wrtdbg(prg,msg);   ! DBG LEV19
    write(msg,'(" nominal_prof_ncyc2: ",i8  )') nominal_prof_ncyc2;                     call wrtdbg(prg,msg);   ! DBG LEV19
    write(msg,'(" nominal_prof_pres2: ",f8.1)') nominal_prof_pres2;                     call wrtdbg(prg,msg);   ! DBG LEV19
    if(nominal_prof_ncyc2 > 0)then;                                                                             ! DBG LEV19
        write(msg,'(" nominal_prof_ncyc1: ",i8  )') nominal_prof_ncyc1;                 call wrtdbg(prg,msg);   ! DBG LEV19
        write(msg,'(" nominal_prof_pres2: ",f8.1)') nominal_prof_pres2;                 call wrtdbg(prg,msg);   ! DBG LEV19
    else                                                                                                        ! DBG LEV19
        write(msg,'(" nominal_prof_pres2: FILL")');                                                             ! DBG LEV19
    endif                                                                                                       ! DBG LEV19
endif														! DBG LEV19

! ============================================================================================
! 20200323 - for now, just exit with an error if a bounce float is found
bounce_float = .false.;
if(trim(inst_type) == "APEX_TSB1")then
    write(errmsg(1),'("FATAL ERROR 602 APEX_TSB1 was identified as the instrument type")')
    write(errmsg(2),'("FATAL ERROR 602 APEX_TSB1 is a bounce float, so we cannot process float",a)')trim(profile);
    call error_exit(prg,602,2,errmsg); ! ERR FAT
endif
! ============================================================================================
! Analyze the instrument type to see if we have DOXY
! Note that I search for TSO, not just O - however, I do need to filter ou the PJ floats
DOXY_float = .false.; ! We have not yet checked if we have DOXY
if(make_ncprof)then
    make_ncbiop = .false.; profver3p0 = .false.;  profver3p1 = .true.; ! Default to non-DOXY float
    ! the next section allows you to "force" 3.0 FORMAT_VERSION profiles through the env var
    call get_required_envvar(prg,'NCPROF_FORMAT_VERSION',ans4);
    if(ans4 == FORMAT_VERSION_3p1)then;
        profver3p1 = .true.;  profver3p0 = .false.; outRDOXY = .false.; ! envvar: profver3p1
	write(msg,'("The env var ncprof format version is ",a)')FORMAT_VERSION_3p1; call wrtdbg(prg,msg);
    elseif(ans4 == FORMAT_VERSION_3p0)then;
        profver3p1 = .false.; profver3p0 = .true.;  outRDOXY = .true.;  ! DO put DOXY into the R-file
	write(msg,'("The env var ncprof format version is FORCED to ",a)')FORMAT_VERSION_3p0;	call wrtdbg(prg,msg);
	go to 40; ! SKIP TO FORCED FORMAT_VERSION
    else
        write(errmsg(1),'("FATAL ERROR 406 @1 An invalid FORMAT_VERSION env var was found for NCPROF")')
        write(errmsg(2),'("FATAL ERROR 406 @1 The NCPROF_FORMAT_VERSION was ",a)')trim(ans4);
        call error_exit(prg,406,2,errmsg);; ! qcplus - invalid env var for NCPROF_FORMAT_VERSION
    endif

     write(msg,'("BIO Test the inst_type (",a,") to see if DOXY is present")')trim(inst_type); call wrtdbg(prg,msg);
    if(index(inst_type,"TSO") > 0)then
	write(msg,'("BIO The inst_type (",a,") indecates that DOXY may be present")')trim(inst_type); call wrtdbg(prg,msg); !
	if(index(inst_type,"PJ") > 0)then
	    write(msg,'("BIO The inst_type indecates a PJ float, DOXY is NOT present")');call wrtdbg(prg,msg); !
	else
	    write(msg,'("BIO The inst_type indecates that DOXY IS present")'); call wrtdbg(prg,msg);
	    DOXY_float = .true.; ! We have a float with DOXY, but do not yet know if we can do the v3p1 BR_file
	    ! 20170316 Test for the env var MAKE_NCBIOP - at CLS, set the env var to F, until the BR files are loaded
	    ans1="F"; call get_default_envvar(prg,"MAKE_NCBIOP",ans1); 
	    if(ans1 == "F")then
		make_ncbiop = .false.; profver3p1 = .false.;   profver3p0 = .true.;  outRDOXY = .true.; ! DO put DOXY in R-file
		write(msg,'("NCBIOP The value of MAKE_NCBIOP is F, Do NOT make the BR file, revert to v3.0 R_file.")')
	    ! There are still two instrument types we cannot handle in B-files, force these to v3p0
	    elseif(inst_type == "APEXIR_TSO7")then
		make_ncbiop = .false.; profver3p1 = .false.;   profver3p0 = .true.;  outRDOXY = .true.; ! DO put DOXY in R-file
		write(msg,'("BIO We canot yet mak a B-fiule for PEXIR_TSO7 (dab): ")'); call wrtdbg(prg,msg); !
	    elseif(inst_type == "APEXIR_TSO9")then
		make_ncbiop = .false.; profver3p1 = .false.;   profver3p0 = .true.;  outRDOXY = .true.; ! DO put DOXY in R-file
		write(msg,'("BIO We canot yet mak a B-fiule for PEXIR_TSO9 (dac): ")'); call wrtdbg(prg,msg); !
	    else
		make_ncbiop = .true.; profver3p1 = .true.;   profver3p0 = .false.;  outRDOXY = .false.; ! Do NOT put DOXY in R-file
		l=LBIOP; filmsg(l:l) = 'r'; result_ncbiop = 'r';
		write(msg,'("BIO We can make the B-file")'); call wrtdbg(prg,msg); !
	    endif
	endif
    else; ! TSO is NOT in the inst_type
	write(msg,'("BIO The inst_type ndecates that DOXY is NOT present")'); call wrtdbg(prg,msg); !
    endif
    write(msg,'("BIO The FORMAT_VERSION logicals are: make_ncbiop: ",l1," profver3p0: ",l1," profver3p1: ",l1)') &
	make_ncbiop,profver3p0,profver3p1;
    call wrtdbg(prg,msg); !
    40 continue; ! SKIP TO FORCED FORMAT_VERSION
    write(msg,'("BioARGO FORMAT_VERSION: profver3p0: ",l1,"  profver3p1: ",l1)')profver3p0,profver3p1; call wrtdbg(prg,msg);
    write(msg,'("BioARGO   DOXY-related: DOXY_float: ",l1," make_ncbiop: ",l1)')DOXY_float,make_ncbiop; call wrtdbg(prg,msg);
    ! Now that we know our status, determine the rest of the variables
    if(profver3p1)then
	prof_FORMAT_VERSION = FORMAT_VERSION_3p1;
        prof_USER_MANUAL=USER_MANUAL_3p2; lumv = 3; ! Length of User Manual Version
        prof_global_conventions = global_conventions_3p2;
        prof_cycnum_conventions = prof_cycnum_conventions_3p2
    elseif(profver3p0)then;
        prof_FORMAT_VERSION = FORMAT_VERSION_3p0;
        prof_USER_MANUAL=USER_MANUAL_3p0;; lumv = 4; ! Length of User Manual Version
        prof_global_conventions = global_conventions_3p0;
        prof_cycnum_conventions = cycnum_conventions_3p0
    else
        write(errmsg(1),'("FATAL ERROR 407 @3 An invalid FORMAT_VERSION env var was found for NCPROF")')
        write(errmsg(2),'("FATAL ERROR 407 @3 The NCPROF_FORMAT_VERSION was ",a)')trim(testch4);
        call error_exit(prg,407,2,errmsg);; ! qcplus - invalid env var for NCPROF_FORMAT_VERSIONA
    endif
endif

! ============================================================================================
! All of the data has been loaded, change filmsg depending on which files we need
! U means the file requested, status undetermined, n means the file was NOT requested

call wrtflm(prg,'@0 Initial values before assignment');
l=LQC;   if(make_qcprof)then; filmsg(l:l) = 'r'; result_qcprof = 'r'; else; filmsg(l:l) = 'n'; result_qcprof = 'n'; endif; l=0;
l=LNC;   if(make_ncprof)then; filmsg(l:l) = 'r'; result_ncprof = 'r'; else; filmsg(l:l) = 'n'; result_ncprof = 'n'; endif; l=0;
l=LMETA; if(make_ncmeta)then; filmsg(l:l) = 'r'; result_ncmeta = 'r'; else; filmsg(l:l) = 'n'; result_ncmeta = 'n'; endif; l=0;
l=LTECH; if(make_nctech)then; filmsg(l:l) = 'r'; result_nctech = 'r'; else; filmsg(l:l) = 'n'; result_nctech = 'n'; endif; l=0;
l=LTRAJ; if(make_nctraj)then; filmsg(l:l) = 'r'; result_nctraj = 'r'; else; filmsg(l:l) = 'n'; result_nctraj = 'n'; endif; l=0;
l=LBIOP; if(make_ncbiop)then; filmsg(l:l) = 'r'; result_ncbiop = 'r'; else; filmsg(l:l) = 'n'; result_ncbiop = 'n'; endif; l=0;
l=LBIOT; if(make_ncbiot)then; filmsg(l:l) = 'r'; result_ncbiot = 'r'; else; filmsg(l:l) = 'n'; result_ncbiot = 'n'; endif; l=0;
! OLD l=LTSAC; if(make_tesac)then;  filmsg(l:l) = 'r'; result_tesac  = 'r'; else; filmsg(l:l) = 'n'; result_tesac  = 'n'; endif; l=0;

filmsg(l:l) = 'n'; result_tesac  = 'n'; ! OLD PURGE LATER

call wrtflm(prg,'@0 Initial values after assignment');
if(make_tesac)then;
    l=LTSAC; 
    if(send_to_GTS)then;
	filmsg(l:l) = 'r'; result_tesac  = 'r';
    else;
	filmsg(l:l) = 'n'; result_tesac  = 'n';
	make_tesac = .false.; only_tesac = .false.
	write(msg,'("Profile: ",a20" send_to_GTS is FALSE, set write_tesac=F")')trim(profile);
	call wrttrc(prg,msg);
    endif;
    l=0;
endif
call wrtflm(prg,'@1 Initial values after assignment');
l=0;
! ============================================================================================
if(trim(inst_type) == "SOLOOF_TS10")then
    if(DEBUG .and. make_qcprof) write(DBG,'("The inst_type is SOLOOF_TS10, make_qcprof is T, make the qcprof file.")');
    if(DEBUG .and. make_ncprof) write(DBG,'("The inst_type is SOLOOF_TS10, make_ncprof is T, make the ncprof file.")');
    if(DEBUG .and. make_ncmeta) write(DBG,'("The inst_type is SOLOOF_TS10, make_ncmeta is T, make the ncmeta file.")');
    if(DEBUG .and. make_nctech) write(DBG,'("The inst_type is SOLOOF_TS10, make_nctech is T, but do NOT make the nctech file.")');
    if(DEBUG .and. make_nctraj) write(DBG,'("The inst_type is SOLOOF_TS10, make_nctraj is T, but do NOT make the nctraj file.")');
    if(DEBUG .and. make_ncbiop) write(DBG,'("The inst_type is SOLOOF_TS10, make_ncbiop is T, but do NOT make the ncbiop file.")');
    if(DEBUG .and. make_ncbiot) write(DBG,'("The inst_type is SOLOOF_TS10, make_ncbiot is T, but do NOT make the ncbiot file.")');
    l=LTECH; if(make_nctech)then; make_nctech = .false.; filmsg(l:l) = 'N'; endif ! SOLOOF
    l=LTRAJ; if(make_nctraj)then; make_nctraj = .false.; filmsg(l:l) = 'N'; endif ! SOLOOF
    l=LBIOP; if(make_ncbiop)then; make_ncbiop = .false.; filmsg(l:l) = 'N'; endif ! SOLOOF
    l=LBIOT; if(make_ncbiot)then; make_ncbiot = .false.; filmsg(l:l) = 'N'; endif ! SOLOOF
    l=0;
endif
call wrtflm(prg,'@2 before meta file/xxx-version');
call wrtflm(prg,'@xxx3 Initial values before call to write_meta');
! ============================================================================================
! If this is the case where we want to create a metanc fle without profiles, read config & sensormodel tables, jump down to it
if(ncmeta_noprof)then
    call get_required_envvar(prg,'NCFILES_DIR',pathname_ncdir)
    if(index(pathname_ncdir,"/") .ne. 1)then
	write(errmsg(1),'("FATAL ERROR 906 The output ncmeta filename could not be defined")')
        write(errmsg(2),'("FATAL ERROR 906 This is for the cycle=xxx case, no profiles are present yet")')
        write(errmsg(3),'("FATAL ERROR 906 Check that NCFILES_DIR is defined in the environment.")')
	call error_exit(prg,906,3,errmsg); ! qcplus bad env NCFILES_DIR, for xxx meta job
    endif
    pathname_ncmeta = trim(pathname_ncdir) // trim(wmoid) // "_meta.nc";
    write(msg,'("ncmeta_noprof, The meta file has been read, skip to writing it: ",a)'); call wrttrc(prg,msg);
    
    ! NOTE OFFSET BELOW
        call get_required_envvar(prg,'CONFIG_TABLE',pathname_config_table);
        call get_required_envvar(prg,'CONFIG_TABLE_SKIP',pathname_config_table_skip);
	if(DEBUG)then
	    write(msg,'("CRNC EXT CNFG pathname_config_table: ",a)')pathname_config_table;		call wrtdbg(prg,msg);
	    write(msg,'("CRNC EXT CNFG pathname_config_table_skip: ",a)')pathname_config_table_skip;	call wrtdbg(prg,msg);
	endif
	call get_required_envvar(prg,'CONFIG_MISS_list',pathname_config_miss);
	msc_open=open_app_file(MSC,pathname_config_miss,'MSC','missing config parameter list')
	call get_required_envvar(prg,'SENSOR_MODEL_MISS_list',pathname_sensor_miss);
	mss_open=open_app_file(MSS,pathname_sensor_miss,'MSS','missing sensor_model definitions list')
        ! Now, read the config+skip table
        ret=read_configtable(); ! cyc=xxx
        if(ret == 0)then        ! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCMETA read_configtable was successful")'); call wrtdbg(prg,msg); endif           ! DBG
        else
            ! Note that all error conditions are reported in the cal itself
            make_ncmeta = .false.; result_ncmeta = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_configtable, set make_ncmeta=F, result_ncmeta=F")')
            call wrttrc(prg,msg);
        endif
        call get_required_envvar(prg,'SENSOR_MODEL_TABLE',pathname_sensor_model_table);
        if(DEBUG)then
            write(msg,'("CRNC EXT SNSR @1 pathname_sensor_model_table: ",a)')trim(pathname_sensor_model_table);
            call wrtdbg(prg,msg);
        endif
        ! Now, read the sensor table
        ret=read_sensormodeltable(); ! cyc=xxx
        if(ret == 0)then        ! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCMETA read_sensormodeltable was successful")'); call wrtdbg(prg,msg); endif           ! DBG
        else
            ! Note that all error conditions are reported in the cal itself
            make_ncmeta = .false.; result_ncmeta = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_sensormodeltable, set make_ncmeta=F, result_ncmeta=F")')
            call wrttrc(prg,msg);
        endif
        !Calling the table which has  PARAMETER info for the META NC File
        call get_required_envvar(prg,'SENSOR_PARAMS_TABLE',pathname_sensor_params_table);
        if(DEBUG)then
            write(msg,'("CRNC EXT SNSR @1 pathname_sensor_params_table: ",a)')trim(pathname_sensor_params_table);
            call wrtdbg(prg,msg);
        endif
        ! Now, read the pathname_sensor_params_table
        ret=read_sensor_params_table(); ! cyc=xxx
        if(ret == 0)then        ! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCMETA read_sensor_params_table was successful")'); call wrtdbg(prg,msg); endif           ! DBG
        else
            ! Note that all error conditions are reported in the cal itself
            make_ncmeta = .false.; result_ncmeta = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_sensor_params_table, set make_ncmeta=F, result_ncmeta=F")')
            call wrttrc(prg,msg);
        endif
    ! NOTE OFFSET ABOVE
    ! Note that this is called when get_all_qc will NOT be called, we have no profiles
    ret = prepare_launch_config(-1); ! <>_xxx means no profiles, only launch info in meta file is needed
    if(DEBUG) write(DBG,'("QC+RNC EXT call gen_all_qc")')
    ret=get_all_qc(pathname_qcprof)
    if(DEBUG) write(DBG,'("QC+RNC EXT rtrn gen_all_qc")')
    if(DEBUG)then; write(msg,'("CRNC RDQ ALL return value from get_all_qc: ",i1)')ret; call wrtdbg(prg,msg); endif

    go to 889;	! Just before write_ncmeta()
endif

! You still need the name of the qc file, even if you will not be
! creating a new one - later, open the old phy file for what ou need

call get_required_envvar(prg,'QCFILES_DIR',pathname_qcdir)
call get_required_envvar(prg,'QCFILES_AOMLID_DIR',pathname_aomlid_qcdir)

if(phy_descending)then; qcextn = "D.qc"; else; qcextn = ".qc"; endif	! Do we need the D in the output qc file?
qcfile = compose_profname(prg,float_name,thiscyc,qcextn)
qcprof = compose_profname(prg,float_name,thiscyc,qcextn)
pathname_qcprof = trim(pathname_qcdir) // trim(qcprof);
pathname_aomlid_qcprof = trim(pathname_aomlid_qcdir) // trim(qcprof);

if(make_ncprof .or. make_ncmeta .or. make_nctraj .or. make_nctech .or. make_ncbiop .or. make_ncbiot)then
    call get_required_envvar(prg,'NCFILES_DIR',pathname_ncdir);
    if(make_ncprof .or. make_ncbiop)then
	if(phy_descending)then; ncextn = "D.nc"; else; ncextn = ".nc"; endif    ! Do we need the D in the output nc file?
	ncfile=compose_profname(prg,wmoid,thiscyc,ncextn)
	if(make_ncprof) pathname_ncprof = trim(pathname_ncdir) //  "R" // trim(ncfile);
	if(make_ncbiop) pathname_ncbiop = trim(pathname_ncdir) // "AOML_BR" // trim(ncfile);
    endif
    if(make_ncmeta)then
	pathname_ncmeta = trim(pathname_ncdir) // trim(wmoid) // "_meta.nc"
	call get_required_envvar(prg,'CONFIG_TABLE',pathname_config_table);
	call get_required_envvar(prg,'CONFIG_TABLE_SKIP',pathname_config_table_skip);
	if(DEBUG)then
	    write(msg,'("CRNC EXT CNFG pathname_config_table: ",a)')pathname_config_table;     ; call wrtdbg(prg,msg);
	    write(msg,'("CRNC EXT CNFG pathname_config_table_skip: ",a)')pathname_config_table_skip; call wrtdbg(prg,msg);
	endif
	call get_required_envvar(prg,'CONFIG_MISS_list',pathname_config_miss);
        msc_open=open_app_file(MSC,pathname_config_miss,'MSC','missing config parameter list')
        call get_required_envvar(prg,'SENSOR_MODEL_MISS_list',pathname_sensor_miss);
        mss_open=open_app_file(MSS,pathname_sensor_miss,'MSS','missing sensor_model definitions list')
	! Now, read the config+skip table
        ret=read_configtable();
        if(ret == 0)then        ! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCMETA read_configtable was successful")'); call wrtdbg(prg,msg); endif           ! DBG
        else
            ! Note that all error conditions are reported in the cal itself
            make_ncmeta = .false.; result_ncmeta = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_configtable, set make_ncmeta=F, result_ncmeta=F")')
            call wrttrc(prg,msg);
        endif
	call get_required_envvar(prg,'SENSOR_MODEL_TABLE',pathname_sensor_model_table);
	if(DEBUG)then
	    write(msg,'("CRNC EXT SNSR @2 pathname_sensor_model_table: ",a)')trim(pathname_sensor_model_table);
	    call wrtdbg(prg,msg);
	endif
	! Now, read the sensor table
	ret=read_sensormodeltable(); ! cyc=nnn
        if(ret == 0)then        ! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCMETA read_sensormodeltable was successful")'); call wrtdbg(prg,msg); endif           ! DBG
        else
            ! Note that all error conditions are reported in the cal itself
            make_ncmeta = .false.; result_ncmeta = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_sensormodeltable, set make_ncmeta=F, result_ncmeta=F")')
            call wrttrc(prg,msg);
        endif
        !Calling the table which has  PARAMETER info for the META NC File
        call get_required_envvar(prg,'SENSOR_PARAMS_TABLE',pathname_sensor_params_table);
        if(DEBUG)then
            write(msg,'("CRNC EXT SNSR @2 pathname_sensor_params_table: ",a)')trim(pathname_sensor_params_table);
            call wrtdbg(prg,msg);
        endif
        ! Now, read the pathname_sensor_params_table

        ret=read_sensor_params_table(); ! cyc=nnn
        if(ret == 0)then        ! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCMETA read_sensor_params_table was successful")'); call wrtdbg(prg,msg); endif           ! DBG
        else
            ! Note that all error conditions are reported in the cal itself
            make_ncmeta = .false.; result_ncmeta = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_sensor_params_table, set make_ncmeta=F, result_ncmeta=F")')
            call wrttrc(prg,msg);
        endif
    endif
    if(make_nctraj)then
        pathname_nctraj = trim(pathname_ncdir) // trim(wmoid) // "_Rtraj.nc"
        call get_required_envvar(prg,'TRAJ_TABLE',pathname_traj_table);
	call get_required_envvar(prg,'TRAJ_MC_TABLE',pathname_traj_mc_table);
        call get_required_envvar(prg,'TRAJ_TABLE_SKIP',pathname_traj_table_skip);
	! read traj tables
	ret=read_trajtable()
        if(ret == 0)then        ! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCTRAJ read_trajtable was successful")'); call wrtdbg(prg,msg); endif           ! DBG
        else
            ! Note that all error conditions are reported in the cal itself
            make_nctraj = .false.; result_nctraj = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_trajtable, set make_nctraj=F, result_nctraj=F")')
            call wrttrc(prg,msg);
        endif
    endif
    if(make_ncbiot)then
	pathname_ncbiot = trim(pathname_ncdir) // trim(wmoid) // "_BRtraj.nc"
	call get_required_envvar(prg,'TRAJ_TABLE',pathname_config_table);
	call get_required_envvar(prg,'TRAJ_TABLE_SKIP',pathname_config_table_skip);
    endif
    if(make_nctech)then
        pathname_nctech = trim(pathname_ncdir) // trim(wmoid) // "_tech.nc"
        call get_required_envvar(prg,'TECH_TABLE',pathname_tech_table);					! NCTECH TABL
        call get_required_envvar(prg,'TECH_TABLE_SKIP',pathname_tech_table_skip);			! NCTECH SKIP
	call get_required_envvar(prg,'TECH_MISS_list',pathname_tech_miss); 				! NCTECH MISS_TECH
	mst_open=open_app_file(MST,pathname_tech_miss,'MST','missing tech parameter list');		! NCTECH MISS_TECH
        ! read technical tables
        ret=read_techtable();										! NCTECH RDTABS
        if(ret == 0)then	! SUCCESS  = 0;
            if(DEBUG)then; write(msg,'("NCTECH read_techtable was successful")'); call wrtdbg(prg,msg); endif		! DBG
        else
	    ! Note that all error conditions are reported in the cal itself
            make_nctech = .false.; result_nctech = 'F'      ! can't do the file without the parameters/skips
            write(msg,'("QC+ Some kind of error occurred in read_techtable, set make_nctech=F, result_nctech=F")')
	    call wrttrc(prg,msg);
        endif
    endif
endif
if(make_tesac)then
    call get_required_envvar(prg,'ftpgts_tabfile',pathname_ftpgts);
    call get_required_envvar(prg,'tesac_tabfile', pathname_2tesac);
    call get_required_envvar(prg,'to_gtsgateway_output',pathname_tesac)
    if(DEBUG)then; write(msg,*)'TEST TESAC at 1 pathname_tesac: ',trim(pathname_tesac); call wrtdbg(prg,msg); endif
    filename_tesac=pathname_tesac(index(pathname_tesac,"/",BACK = .true.)+1:len(trim(pathname_tesac)))
    if(DEBUG) pathname_tesac = pathname_tesac // "." // trim(profile)
    ! if only the tesac file is needed, we will NOT do qca1_climatology or qca2_analysis
    only_tesac=.true.;
    if(make_qcprof .or. make_ncprof .or. make_nctraj .or. make_nctech .or. make_ncbiop .or. make_ncbiot) only_tesac=.false.
endif


if(DEBUG)then; write(msg,*)'TEST TESAC l@2 logicals: ',send_to_GTS,make_tesac; call wrtdbg(prg,msg); endif
!=======================================================================================================
!
! Load the phy file, store what is needed for the nc file, but do NOT start writing the qc file

! Get the input phy directory, attach the pyfile name
call get_required_envvar(prg,'PHYFILES_DIR',pathname_phydir);
pathname_phyfile = trim(pathname_phydir) // trim(phyfile);

if(DEBUG) write(DBG,'("DBGpresadj QC+r_phy B found_surf_pres: ",l1," ln: ",i3,x,a)')found_surf_pres, & ! DBG LEV9+
    len(trim(surf_pres_comment)),trim(surf_pres_comment);                                                  ! DBG LEV9+

ret=read_phy(pathname_phyfile)

!===========================================================================================================
if(DEBUG) write(DBG,'("DBG presadj QC+r_phy E found_surf_pres: ",l1," ln: ",i3,x,a)')found_surf_pres, & ! DBG LEV9+
   len(trim(surf_pres_comment)),trim(surf_pres_comment);                                                   ! DBG LEV9+

if(make_qcprof .or. make_ncprof .or. make_ncbiop .or. make_tesac)then
    skip_profile_qctests = .false.
else
    skip_profile_qctests = .true.
endif

if(phy_descending)then
    write(msg,'("ASC/DSC This provile is DESCENDING")');
else
    write(msg,'("ASC/DSC This provile is ASCENDING")');
endif
call wrtlog(prg,msg)

! ===========================================================================================================
! Retrieve the various format versions for requested files (prof done earlier)
if(make_ncmeta) call get_required_envvar(prg,'NCMETA_FORMAT_VERSION',meta_FORMAT_VERSION);
if(ncmeta_noprof)then                                               ! NCMETA_FORMAT_VERSION KLUGE
    meta_FORMAT_VERSION = "3.1"; ! NCMETA_FORMAT_VERSION KLUGE      ! NCMETA_FORMAT_VERSION KLUGE
endif                                                               !  NCMETA_FORMAT_VERSION KLUGE
if(make_nctech) call get_required_envvar(prg,'NCTECH_FORMAT_VERSION',tech_FORMAT_VERSION);
if(make_nctraj) call get_required_envvar(prg,'NCTRAJ_FORMAT_VERSION',traj_FORMAT_VERSION);

!=======================================================================================================
! Now that the phy file has been rad, we can determine the CONFIG_MISSION number

if(config_float_mission_present)then
    ! int_CONFIG_MISSION_NUMBER = is defined by the CONFIG FLOAT MISSION valuew in the phy file - value assigned in read_phy
    config_mission_type = 'CM';
    config_mission_comment = 'CONFIG_MISSION_NUMBER is from CINFUG FLOAT MISSION (defined in data file header)'
    if(DBLEV==39) write(msg,'("CMN QC+ CMN TYPE: ",a, " CMN: ",i6)')config_mission_type,int_CONFIG_MISSION_NUMBER
    if(int_CONFIG_MISSION_NUMBER > 2000)then;
	cmnt2 = cmnt2 // ' and is FILL_VALUE';
	if(DBLEV==39) write(msg,'("CMN QC+ CMN TYPE: ",a, " CMN: ",i6" and is FILL")')config_mission_type,int_CONFIG_MISSION_NUMBER
    endif
elseif(config_lines_present)then
    ! int_CONFIG_MISSION_NUMBER = is defined as the cycle number, as CONFIG lines exitst in the in phy file
    int_CONFIG_MISSION_NUMBER = thiscyc;
    if(trans_type == 'IRIDIUM')then
	config_mission_type = 'IC';
    else
	config_mission_type = 'AC';
    endif
    config_mission_comment = 'CONFIG_MISSION_NUMBER is the cycle number (there are CONFIG lines in the data file header'
elseif(double_nominal_prof_pres)then
    int_CONFIG_MISSION_NUMBER = 999;	! FIX TEST DOUBLE
    if(trim(trans_type) == 'ARGOS')then;
	config_mission_type = 'AD';
    else
	config_mission_type = 'ID';
    endif
    config_mission_comment = 'CONFIG_MISSION_NUMBER two missions (two nominal profile press values in the meta file)'

    if(DEBUG)then
	write(msg,*)'CMN QC+ mission_type == AD/ID, nominal_prof_pres1: ',nominal_prof_pres1; call wrtdbg(prg,msg);
	write(msg,*)'CMN QC+ mission_type == AD/ID, nominal_prof_pres2: ',nominal_prof_pres2; call wrtdbg(prg,msg);
	write(msg,*)'CMN QC+ mission_type == AD/ID, nominal_prof_ncyc1: ',nominal_prof_ncyc1; call wrtdbg(prg,msg);
	write(msg,*)'CMN QC+ mission_type == AD/ID, nominal_prof_ncyc2: ',nominal_prof_ncyc2; call wrtdbg(prg,msg);
    endif
    if(nominal_prof_ncyc1 > 4)then
	write(msg,*)'CMN QC+ nominal_prof_ncyc1 > 4, treat as single change of mission'; call wrtdbg(prg,msg);
	write(msg,*)'CMN QC+ mission_type == D, current cycle: ',thiscyc; call wrtdbg(prg,msg);
	if(thiscyc > nominal_prof_ncyc1)then
	    int_CONFIG_MISSION_NUMBER = 2;
	else
	    int_CONFIG_MISSION_NUMBER = 1;
	endif
    else
	! 29Feb2016 - for cycle 000, no levels, use int_CONFIG_MISSION_NUMBER = 1
	! The 'D' are only APEX_, argos, these have (or should have) no profle in cycle 000/ (per CS)
	! We should NOT have any cycle 000 files with actual profile levels - these are only SOLO
	! If we DO get a cycl0 with profile levels, issue a NON-FATAL ERROR, process as usual, but
	! take a look at it
	if(thiscyc == 0)then
	    int_CONFIG_MISSION_NUMBER = 1; ! cyc== zero, use this, even if nlev>0, but reort an error
	    if(nlev > 0)then
		if(DEBUG)then; write(msg,'("QC+ CMN TYPE is D, cycle zero, nlev NOT zero")'); call wrtdbg(prg,msg); endif
		if(DEBUG)then; write(msg,'("QC+ CMN TYPE is D, report this as a NON-FATAL ERROR")'); call wrtdbg(prg,msg); endif
		write(errmsg(3),'("NON-FATAL ERROR 203 profile: ",a)')trim(profile)
		write(errmsg(1),'("NON-FATAL ERROR 203 CME ARGO/cyc000, but nonzero nlev: ",i5)')nlev
		write(errmsg(2),'("NON-FATAL ERROR 203 CME This should NOT occurr, tell Vicki")')
		call error_report(prg,203,3,errmsg); ! CME cyc000, but nonzero nlev
	    elseif(DEBUG)then
		write(msg,'("QC+ CMN TYPE is D, cycle zero, nlev zero")'); call wrtdbg(prg,msg);
	    endif
	else
	    ! cyc>000, nominal_prof_pres1 nominal_prof_pres2 is 1 2, 1 3, 2 1, or 3 1
	    write(msg,*)'qcplus, nominal_prof_ncyc1 <= 9, treat as alternating NO READY '; call wrtdbg(prg,msg);
	    int_CONFIG_MISSION_NUMBER = FILLINT;	! Until we can fully handle doubles
	    if(config_lines_present)then
		write(msg,*)'qcplus, F figure out how to handle this case, if it ever jappens'; call wrtlog(prg,msg);
		call direct_exit(prg,999,'odd problem with CONFIG/cyc>000'); ! SAV odd problem with CONFIG/cyc>000
	    endif
	    write(msg,*)'qcplus, config_lines_present is FALSE, treat as normal alternating mission'; call wrtdbg(prg,msg);
	    if(nominal_prof_ncyc1==1 .and. nominal_prof_ncyc2==3)then
		int_CONFIG_MISSION_NUMBER = mission13(thiscyc)
	    elseif(nominal_prof_ncyc1==3 .and. nominal_prof_ncyc2==1)then
		int_CONFIG_MISSION_NUMBER = mission31(thiscyc)
	    elseif(nominal_prof_ncyc1==1 .and. nominal_prof_ncyc2==2)then
		int_CONFIG_MISSION_NUMBER = mission12(thiscyc)
	    elseif(nominal_prof_ncyc1==2 .and. nominal_prof_ncyc2==1)then
		int_CONFIG_MISSION_NUMBER = mission21(thiscyc)
	    else
		if(DEBUG)then; write(msg,'("QC+ CMN TYPE is D, cycle zero, nlev NOT zero")'); call wrtdbg(prg,msg); endif
		if(DEBUG)then; write(msg,'("QC+ CMN TYPE is D, report this as a NON-FATAL ERROR")'); call wrtdbg(prg,msg); endif
		write(errmsg(3),'("NON-FATAL ERROR 204 profile: ",a)')trim(profile)
		write(errmsg(1),'("NON-FATAL ERROR 204 CME  alternating, D, but no 12,13,21,31???")')
                write(errmsg(2),'("NON-FATAL ERROR 204 CME This should NOT occurr, tell Vicki")')
		call error_report(prg,204,3,errmsg); ! + CME error
	    endif
	endif
    endif
elseif(double_nominal_drft_pres)then;	! A few very old floats have this
    if(mod(thiscyc,2) /= 0)then
	int_CONFIG_MISSION_NUMBER = 1;
    else
	int_CONFIG_MISSION_NUMBER = 2;
    endif
    config_mission_type = 'DD';
    config_mission_comment = 'CONFIG_MISSION_NUMBER from double nominal drift pres, alternating 1,2,1,2...'
else
    int_CONFIG_MISSION_NUMBER = 1;
    if(trim(trans_type) == 'ARGOS')then;
	config_mission_type = 'AS';
    else
	config_mission_type = 'IS';
    endif
    config_mission_comment = 'CONFIG_MISSION_NUMBER single mission(one nominal profile pressure in the meta file)'
endif

write(msg,'("CMN QC+ CMN: ",i6," CMType: ",a,x,a)')int_CONFIG_MISSION_NUMBER,config_mission_type, &
        trim(config_mission_comment); call wrtlog(prg,msg);

!======================================================================================================
! In like manner, we can also find if any of the salinity profiles are NST or STS profiles
! To do this, we check the VERTICAL_SAMPLING_SCHEME to see if we have an STS profile
if(DBGVSS)then; write(msg,'("NEAR SURF")'); 		call wrtlog(prg,msg); endif
do iprf=1,nprf
    if(index(chr_VERT_SAMPLING_SCHEME(iprf),"Near-surface sampling:") > 0)then;
	if((inst_type(1:7)=="APEXIR_").and.(index(chr_VERT_SAMPLING_SCHEME(iprf),"discrete, unpumped [auxiliary CTD]")>0))then
	    if(DBGVSS)then; write(msg,'("NEAR SURF qcplus iprf: ",i2," ns? Y STS: Y NST: N VERT: ",a)')iprf, &
		trim(chr_VERT_SAMPLING_SCHEME(iprf)); 			call wrtlog(prg,msg); endif
	    near_surface(iprf) = .true.; near_surface(0) = .true.; STS_prof(iprf) = .true.; STS_prof(0) = .true.;
	    do_psal_prof(iprf) = .false.;		! Do NOT PSAL ADJ auxiliary CTD data
	elseif((inst_type(1:5) == "APEX_").and.(index(chr_VERT_SAMPLING_SCHEME(iprf),"discrete, unpumped")>0))then;
	    if(DBGVSS)then; write(msg,'("NEAR SURF qcplus iprf: ",i2," ns? Y STS: N NST: Y VERT: ",a)')iprf, &
		trim(chr_VERT_SAMPLING_SCHEME(iprf)); 			call wrtlog(prg,msg); endif
	    near_surface(iprf) = .true.; near_surface(0) = .true.; NST_prof(iprf) = .true.; NST_prof(0) = .true.;
	else
	    if(DBGVSS)then; write(msg,'("NEAR SURF qcplus iprf: ",i2," ns? Y STS: N NST: N VERT: ",a)')iprf, &
		trim(chr_VERT_SAMPLING_SCHEME(iprf)); 			call wrtlog(prg,msg); endif
	endif
    endif
enddo
if(DBGVSS)then; write(msg,'("NEAR SURF")'); 				call wrtlog(prg,msg); endif
if(DBGVSS)then; write(msg,*)'NEAR SURF near_surface: ',near_surface; 	call wrtlog(prg,msg); endif
if(DBGVSS)then; write(msg,*)'NEAR SURF     NST_prof: ',NST_prof; 	call wrtlog(prg,msg); endif
if(DBGVSS)then; write(msg,*)'NEAR SURF     STS_prof: ',STS_prof; 	call wrtlog(prg,msg); endif
if(DBGVSS)then; write(msg,*)'NEAR SURF      hasPSAL: ',hasPSAL; 		call wrtlog(prg,msg); endif
if(DBGVSS)then; write(msg,*)'NEAR SURF do_psal_prof:   ',do_psal_prof; 	call wrtlog(prg,msg); endif
if(DBGVSS)then; write(msg,'("NEAR SURF")'); 				call wrtlog(prg,msg); endif
if(DBGVSS)then; write(msg,'("NEAR SURF")'); 				call wrtlog(prg,msg); endif
if(DBGVSS .and. DBLEVEXIT)then; write(DBG,'("TEST EXIT")'); call exit(0); endif ! SAV
!=======================================================================================================
! Read the previous qc file with good speed check flag, store positions,date
! and location class of position_qc - pass in name of current phy file, let
! the subrutine find the previous good profile
!
! This function selects the appropriate previous qc file, and then calls read_pqc
! to read the data needed for tests like speed check, grey list,salinity adjustment
!
if(thiscyc > 0)then

    if(DEBUG) write(DBG,'("DBGpresadj QC+r_pqc B found: ",l1," ln: ",i3,1x,a)')found_pqc_mrvsp, & ! DBG LEV9+
	len(trim(pqc_mrvsp_comment)),trim(pqc_mrvsp_comment);                                                 ! DBG LEV9+

    ret=get_pqc(pathname_qcprof)

    if(DEBUG) write(DBG,'("DBGpresadj QC+r_pqc E found: ",l1," ln: ",i3,1x,a)')found_pqc_mrvsp, & ! DBG LEV9+
	len(trim(pqc_mrvsp_comment)),trim(pqc_mrvsp_comment);                                                 ! DBG LEV9+

    if(ret/=SUCCESS)then;
	write(msg,'("QC+ get_pqc  was NOT successful, previous qc file NOT read, ret=",i2)')ret; call wrttrc(prg,msg);
    else
	write(msg,'("QC+ get_pqc WAS successful, previous qc file WAS read, ret=",i2)')ret; call wrttrc(prg,msg);
    endif
else
    prev_good_lat = FILL; prev_good_lon = FILL; prev_good_posn_date = FILL14CH;
    write(msg,'("QC+ get_pqc NOT called for cycle 000")')
endif

if(DEBUG)then; write(msg,'("QC+ return from get_pqc, ret =",i3)')ret; call wrtdbg(prg,msg); endif
! All the data (meta/phy/pqc) had been read in, do we need to adjust pres and/or psal?
if(do_pres_adj .or. do_psal_adj) adjustments = .true.;

if(DBLEV==35)then; write(msg,'("QC+ get_pqc returns: ",i2)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==35 .and. DBLEVEXIT) call dblev_exit("after read_pqc")
if(DEBUG) write(DBG,*)'QC+ DBG adjustments: ',adjustments
 if(DEBUG) write(DBG,*)'QC+ DBG do_pres_adj: ',do_pres_adj
if(adjustments)then;
    if(do_pres_adj)then;								! we should have retrieved mcvsp from pqc
	write(msg,'("QC+ do adjust_pres for thiscyc: ",i4)')thiscyc; call wrtlog(prg,msg);
	call adjust_pres(prg);
	if(do_pres_adj)then;
	    if(DBLEV==37)then; write(msg,'("ADJUST PRES do_pres_adj is STILL true")'); call wrtdbg(prg,msg); endif
	else
	    if(DBLEV==37)then; write(msg,'("ADJUST PRES do_pres_adj is NOW false")'); call wrtdbg(prg,msg); endif
	    msg = 'ADJUST PRES do_psal_adj is';
	    if(do_psal_adj)then;
		if(DBLEV==37)then; write(msg,'(a," true, do not change adjustments")')trim(msg); call wrtdbg(prg,msg); endif
	    else
		adjustments = .false.
		if(DBLEV==37)then; write(msg,'(a," also false, set adjustments to false")'); call wrtdbg(prg,msg); endif
	    endif
	    if(DBLEV==37) call wrtdbg(prg,msg);
	endif		! if(do_pres_adj) #2
    endif		! if(do_pres_adj) #1

    if(do_psal_adj)then
	if(DBLEV==37)then; write(msg,'("ADJUST PSAL do_psal_adj is T")'); call wrtdbg(prg,msg); endif
	call adjust_psal(prg);
	adjustments = .true.
	if(DBLEV==37)then;
	    write(msg,'("ADJUST PSAL adjustment performed")'); call wrtdbg(prg,msg);
	    do iprf=1,nprf
		write(msg,'(a,15x,i1,x,2l2)')trim(msg),iprf,do_psal_prof(iprf),STS_prof(iprf);
	    enddo
	    call wrtdbg(prg,msg);
	    do ilev=1,5 ! nlev
	    write(msg,'("ADJUST  PSAL lev: ",i4)')ilev
		iadj = S(2) -1
		do iprf=1,nprf
		    ireg = iadj+1; iadj=ireg+1;
		    write(msg,'(a,f11.3,f10.3)')trim(msg),profdata(ireg,ilev),profdata(iadj,ilev)
		enddo
		call wrtdbg(prg,msg);
	    enddo
	endif		! if(DBLEV==37)
    endif		! if(do_psal_adj)
    if(do_pres_adj) isPARADJ(1) = .true.;	! is this parameter (PRES) adjusted?
    if(do_psal_adj) isPARADJ(3) = .true.; 	! is this parameter (PSAL) adjusted? 
else
    if(DBLEV==37)then; write(msg,'("ADJUST PRES/PSAL There are NO adjustments")'); call wrtdbg(prg,msg); endif
endif			! if(adjustments)

if(DEBUG)then;
    write(msg,'("====== INPUT IS LOADED, proceed to Tests ==========")'); 	! DBG
    call wrtdbg(prg,msg);							! DBG
endif

write(msg,'("--------------------------------------------------------------------------------")'); call wrtstd(prg,msg);
!
! The tests themselves
!
!========================================================!
QCN='QC19'; QCTEST='Deepest Pressure Test        '
qc19_result=qc19_deepest_pressure(prg,P);write(msg,1000)QCN,"PRES",ret; call wrtlog(prg,msg);

call evaluate_qcresult(QCN);


if(DBLEV==19)then; write(msg,*)'qc19 P returns: ',ret; call wrtdbg(prg,msg); endif
if(DBLEV==19 .and. DBLEVEXIT) call dblev_exit("QC19")
!========================================================!
!   2 Test  1 Platform Identification Test               !
!========================================================!
! WE have obviously identified the platform, so report that
QCN='QC01'; QCTEST='Platform Identification Test '
! This test is NOT USED ret=qc01_Platform_Identification();
! QCTEST_FLAG(iprf,1) is set to 1 in initialize_arrays
!========================================================
! This should NEVER happen, but if it does, we need toknow about it.

!========================================================!
!   3 Test  2 Impossible Date Test                       !
!========================================================!
QCN='QC02'; QCTEST='Impossible Date Test         '
ret=qc02_impossible_date(prg);

lefty = adjustl(profile); write(msg,1004)lefty,nlev,prof_JULD_QC,prof_DATE_TIME_PROFILE,prof_JULD,juld_from
1004 format("CHOICE: ",a16,"new nlev: ",i4," qc: ",a1," I/D: ",a14," JULD: ",f20.11," from: ",a); ! format for selection of JULD
call wrtlog(prg,msg); 
if(DEBUG)then; write(DBG,*)trim(msg); if(DBGPOS .and. DBLEVEXIT)then; call exit(0);endif; endif

lefty = adjustl(profile); write(msg,4000)lefty,prof_JULD_QC,prof_DATE_TIME_PROFILE,trim(juld_from)
4000 format("QC+ DATE_QC after new QC02 ",a20," JULD_QC: ",a1," DATE_TIME_PROFILE: ",a14," juld_from: ",a)
call wrtlog(prg,msg); if(DEBUG) write(DBG,'(a)')trim(msg);

! Added 20191127 - if JULD is fill value, and JULD_QC is NOT 9, issue a non-fatal warning, and turn make_ncprof and ncbiop OFF
if((prof_JULD == FILLDBLE) .and. (prof_JULD_QC /= '9'))then
    lefty = adjustl(profile); write(msg,5001)lefty,prof_JULD_QC,prof_JULD,trim(juld_from)
    5001 format("QC+ BIG TROUBLE profile: ",a20," QC: ",a1," JULD: ",f18.11," from: ",a)
    call wrtlog(prg,msg); if(DEBUG) write(DBG,'("DBG ",a)')trim(msg);
    write(errmsg(1),'("NON-FATAL ERROR 350 in QC+ after qc02, JULD is FILL, DATE is NOT,  QC: ",a)')prof_JULD_QC;
    write(errmsg(2),'("NON-FATAL ERROR 350 This will generate a GDAC REJECTION if the nc file is produced")');
    write(errmsg(3),'("NON-FATAL ERROR 350 The qc file will be generated, but not the R and/ro BR file(0)")');
    call error_report(prg,350,3,errmsg);
    make_ncprof = .false.; make_ncbiop = .false.;
endif

if(DBGSOT)then
    if(DBLEVEXIT)then; 
	write(DBG,'("TEST EXIT DBGSOT ",a)')trim(msg); call exit(0); ! DBG DBLEVEXIT
    else
	write(DBG,'("DBGSOT ",a)')trim(msg); ! DBGSOT
    endif
endif
if(DBLEV== 1)then; write(msg,1001); call wrtdbg(prg,msg); endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC02 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif
1001 format("QCHIST",6x,"np",11x,"1  2  3  4  5  6  7  8  9  0  1  2  3  4  5  6  7  8  9  0  1  2");
1002 format("QCHIST ",a5,i3," flags: ",22i3)

if(ret == 2)then;
    write(repmsg,'(a,"993  4  FFFFFFFF SIOMC TIME CODE ERROR - see: ",a)')profile,trim(pathname_error)
    write(errmsg(1),'(a,"FATAL ERROR 403  4  FFFFFFFF SIOMC TIME CODE ERROR - see: ",a)')profile,trim(pathname_error)
    call error_exit(prg,993,1,errmsg); ! qcplus - SIOMC CODE ERROR (whatever that means)
endif

read(prof_JULD_QC,'(i1)') date_flag
if(date_flag==1 .or. date_flag==8)then; date_good=.true.; else; date_good=.false.; endif

if(DBLEV== 2)then; write(msg,'("QC02 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
!========================================================!
!   4 Test  3 Impossible Location Test                   !
!========================================================!
QCN='QC03'; QCTEST='Impossible Location Test     '
ret=qc03_impossible_location(prg);
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC03 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(ret==PASS)then;		! PASS if at least one position is on earth
    posn_bad = .false.; posn_flag = 1; posn_good = .true.
elseif(ret==FAIL)then;
    posn_bad = .true.;  posn_flag = 4; posn_good = .false.
else
    posn_bad = .true.; posn_flag = 9; posn_good = .false.
endif

if(DBLEV== 3)then; write(msg,'("QC03 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV== 3 .and. DBLEVEXIT) call dblev_exit("QC03")
!========================================================!

! FIX LATER (new method not yet implemented) call evaluate_qctest(ret, 3);
if(DBLEV== 3)then; write(msg,'("QC04 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV== 3 .and. DBLEVEXIT) call dblev_exit("QC03")
!========================================================!
!   5 Test  4 Position on Land Test                      !
!========================================================!
QCN='QC04'; QCTEST='Position on Land Test        '
if(DBLEV== 4)then; write(msg,'("LEV04 qcplus, before qc04 test, posn_flag: ",i2)')posn_flag; call wrtdbg(prg,msg); endif
if(posn_flag == 9)then;
    land_flag = 0; land_good = .false.;
    on_land_result = NOTD;		! FIX all this /_bad vs _flag business - is very unclear
    if(DBLEV== 4)then; write(msg,'("LEV04 qc @1 set on_land_result to NOTD: ",i2)')on_land_result; call wrtdbg(prg,msg); endif
else
    on_land_result=qc04_position_on_land(prg)
    land_bad = .false.; land_flag = 1; land_good = .true.					! assume the best
    if(on_land_result == FAIL)then; land_bad = .true.; land_flag = 4; land_good = .false.; endif	! report the worst
    if(DBLEV== 4)then; write(msg,'("LEV04 qc @2 qc04 returns on_land_result: ",i2)')on_land_result; call wrtdbg(prg,msg); endif
endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC04 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(DBLEV== 4)then; write(msg,'("QC04 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV== 4 .and. DBLEVEXIT) call dblev_exit("QC04")
!========================================================!
!   6 Test  5 Impossible Speed Test                      !
!========================================================!
QCN='QC05'; QCTEST='Impossible Speed Test        '
if(posn_flag/=1)then;	! ALL positions are either missing or bad, ie, not on earth
    write(msg,'("QC05 W Either the date or the position (or both) are bad/missing, no SPEED CHECK")')
    speed_bad = .false.;
    speed_flag = 0; speed_good = .false.;
    speed_result = NOTD;
elseif(date_flag/=1 .and. date_flag/=8)then;
    write(msg,'("QC05 W Either the date or the position (or both) are bad/missing, no SPEED CHECK")')
    speed_bad = .false.; 
    speed_flag = 0; speed_good = .false.;
    speed_result = NOTD;
    if(DBLEV==33) write(msg,*)'LEV33 SPEED_RESULT @ 2: ',speed_result;
else
    speed_result=qc05_impossible_speed(prg);

    if(speed_result == PASS)then;	! There are NO positions that failed the speed check
	 speed_bad = .false.; speed_flag = 1;  speed_good = .true.;
    elseif(speed_result == FAIL)then;	! There is at least ONE position that failed the speed check
	speed_bad = .true.; speed_flag = 4;  speed_good = .false.;
    else				! Speed check test cannot be determined
	speed_bad = .true.; speed_flag = 0;  speed_good = .false.;
    endif
    if(DBLEV==33) write(msg,*)'LEV33 SPEED_RESULT @ 3: ',speed_result;
endif
if(DBLEV== 1)then;
    do iprf=1,nprf;
	write(msg,1002)"QC05 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); call wrtdbg(prg,msg);
	write(DBG,'(a)')trim(msg);										! DBG DBLEG
    enddo
endif
! =========================================================================================================================
! Befire we pick the position, we need to 'fix' the BADGPS dates
if(DBGFIX) write(DBG,'("DBGFIX BADGPS was a bad fix found: ",l2)')badgpsfix_pos_found
if(badgpsfix_pos_found .and. (prof_JULD_QC == '1'))then

    ! Typical position line:
    ! >     -7.909    -95.024 2099/11/09 02:20:20   000   9     0     1     4     1     1 <
    ! >12345678901234567890123456789012345678901234567890123456789012345678901234567890
    !  1 to                 23yyyy/mm/dd34 ti (length of line minuw 34)

    write(msg,'("BADGPS are present in the position block, for :",100l2)')(badgpsfix_pos(i),i=1,npos); call wrtlog(prg,msg);
    if(DEBUG) write(DBG,'(a)')trim(msg);
    if(prof_JULD_QC == "1")then
	write(msg,'("BADGPS will be corrected using the YEAR/MM/DD from the JULD")'); call wrtlog(prg,msg);
	write(msg,'("BADGPS prof_DATE_TIME_PROFILE: ",a)')prof_DATE_TIME_PROFILE
	write(msg,'("BADGPS JULD_year,JULD_mon,JULD_day: ",i5,2i3.2)')JULD_year,JULD_mon,JULD_day
	write(posn_date,'(i4,"/",i2.2,"/",i2.2)')JULD_year,JULD_mon,JULD_day
	if(DEBUG) write(DBG,*)'TEST > ',posn_date,' <';
	do ipos=1,npos
	   if(badgpsfix_pos(ipos))then
		if(DEBUG) write(DBG,*)' OLD: ',trim(posline(ipos))
		read(posline(ipos),'(a23,10x,a)')poslinebeg,poslineend
		write(posline(ipos),'(a23,a10,a)')poslinebeg,posn_date,trim(poslineend)
		if(DEBUG) write(DBG,*)' NEW: ',trim(posline(ipos));
	    endif
	enddo
    else
	write(msg,'("BADGPS will NOT be corrected, AS JULD_QC is not 1")'); call wrtlog(prg,msg);
    endif
endif; ! end of badgpsfix_pos_found
! NOTEST if(DEBUG)then; write(DBG,'("TEST EXIT after fixing badgps.")'); call exit(0); endif
! =========================================================================================================================
!Calling the subroutine to choose the best position for the profile, among the available positions in phy file.
call pick_profile_pos(prg,pathname_phyfile);
if(DEBUG) write(DBG,'("Return from PPP, posloc: ",i3," cmnt: ",a)')posloc,trim(posn_cmnt);
if(DBGPOS) write(DBG,'("DBG POSLOC ret to qc+, posloc: ",i2)')posloc

if(posloc > 0)then; 			! we have a location of some type
    ! we have a location of some type
    ! position-related variables were ititialized to FILL/FALSE and are replaced here
    ! maybe all of this can be moved to pick_profile_pos (if there is no return after setting posloc to something >0)
    iyr=this_year(posloc);
    imo=this_mon(posloc);
    idy=this_day(posloc);
    ihh=this_hh(posloc);
    imn=this_mm(posloc);
    isc=this_sc(posloc);

    if(DBGPOS) write(DBG,'("DBG POSLOC iyr,imo,idy,ihh,imn,isc: ",5i3)')iyr,imo,idy,ihh,imn,isc

    prof_JULD_LOCATION_qc = pos_dateqc(posloc);
    if(prof_JULD_LOCATION_qc == '9')then
	prof_DATE_TIME_LOCATION = "99999999999999";
	prof_JULD_LOCATION = FILLDBLE;
    else
	write(prof_DATE_TIME_LOCATION,'(i4,5i2.2)')iyr,imo,idy,ihh,imn,isc
	prof_JULD_LOCATION = juldays1950(idate);
    endif
    prof_JULD_LOCATION_qc = pos_dateqc(posloc);
    abslat = abs(this_lat(posloc)); abslon = abs(this_lon(posloc)); ! Jury-rig for euler compile
	if(abslat <= 90.0 .and. abslon <= 180.0)then
	prof_LATITUDE  = dble_lat(posloc); real_LATITUDE  = this_lat(posloc);
	prof_LONGITUDE = dble_lon(posloc); real_LONGITUDE = this_lon(posloc);	
	if(trim(trans_type) == 'IRIDIUM' .and. (sat_posn(posloc) == "I" .or. sat_posn(posloc) == "i"))then
	    chr_POSITIONING_SYSTEM='IRIDIUM';
    endif  
    else
	write(msg,'("DBG @0 POSLOC: ",i3," The lat/los valued are fill value")')posloc
	call wrtlog(prg,msg);
    endif
else;                   ! els of  posloc>0
    write(msg,'("POSLOC After return from pick_profile_pos, posloc==zero")'); call wrtlog(prg,msg);
endif;			! end of  posloc>0

write(msg,'("POSLOC      LATITUDE: ",f16.5)')prof_LATITUDE                  ! DBG LEV
write(msg,'("POSLOC     LONGITUDE: ",f16.5)')prof_LONGITUDE                 ! DBG LEV
write(msg,'("POSLOC   POSITION_QC:      ",a1)')prof_POSITION_QC             ! DBG LEV
write(msg,'("POSLOC DATE_TIME_LOC:      ",a)')prof_DATE_TIME_LOCATION       ! DBG LEV
if(prof_JULD_LOCATION > 999990.0)then;
    write(msg,'("POSLOC JULD_LOCATION:      999999.0")')                    ! DBG LEV
else
    write(msg,'("POSLOC JULD_LOCATION: ",f16.5)')prof_JULD_LOCATION         ! DBG LEV
endif
write(msg,'("POSLOC LOCATION_CMNT: ",a)')trim(posn_cmnt)                    ! DBG LEV

! ======================================================================================
! Did we ever get a valid prof_JULD?
if(prof_JULD_QC == '9' .and. prof_JULD_LOCATION /= FILLDBLE)then
    prof_JULD = prof_JULD_LOCATION
    prof_JULD_QC = prof_JULD_LOCATION_qc
    write(msg,'("QC+ GMT prof_JULD filled with JULD_LOCATION: ",f20.12," flag of: ",a1)')prof_JULD,prof_JULD_QC;
    call wrttrc(prg,msg);
endif

if(BADGPS)then
    write(msg,'("QC+ POSN GREYLIST DATE_TIME_PROFILE:  ",a)')prof_DATE_TIME_PROFILE; call wrtdbg(prg,msg);
    write(msg,'("QC+ POSN GREYLIST DATE_TIME_LOCATION: ",a)')prof_DATE_TIME_LOCATION; call wrtdbg(prg,msg);
endif

read(prof_DATE_TIME_PROFILE,'(i4,i2,i2)')JLOC_year,JLOC_mon,JLOC_day; ! save for qc15 tocompare in grey list check

if(DBLEV==50)then
    write(msg,'("QC+ POSN GREYLIST yyyy,mm,dd: ",i4,i2,i2)')JLOC_year,JLOC_mon,JLOC_day;  call wrtdbg(prg,msg);
endif


if(int_POSITION_QC>1)then; ret = FAIL; else; ret = PASS; endif

if(DBLEV== 5)then;
    do i=1,npos
        write(msg,'("LEV05 POS QC  pos ",i2," timqc: ",a" ",a,2x,a1)')i,pos_dateqc(i),trim(posline(i)),pos_dateqc(i);
	call wrtdbg(prg,msg);
    enddo
    write(msg,'("Found position ",i2," LAT: ",f9.2," LON: ",f9.2," QC: ",a1)') &
	i,prof_LATITUDE,prof_LONGITUDE,prof_POSITION_QC

    call wrtdbg(prg,msg);
endif
if(int_POSITION_QC>1)then; ret = FAIL; else; ret = PASS; endif ! ????? FIX THIS - IS IT STILLL VALID ???
!========================================================!
! Do we actually HAVE profile data to qc?
if(nlev==0)then
    if(trim(ccyc)=='000' .or. trim(ccyc)=='0000')then
	JOB_STATUS = no_data_lines_000_status;
	if(DEBUG) write(DBG,'("JOB_ST PROF @1 Set JOB_STATUS: ",i2," no_data_lines_000_status")')JOB_STATUS
	write(msg,'(a," set JOB_STATUS = no_data_lines_000_status")')trim(msg);
    else
	JOB_STATUS = no_data_lines_nnn_status;
	if(DEBUG) write(DBG,'("JOB_ST PROF @2 Set JOB_STATUS: ",i2," no_data_lines_nnn_status")')JOB_STATUS
	write(msg,'(a," set JOB_STATUS = no_data_lines_nnn_status")')trim(msg);
	if(DBLEV==33) write(msg,*)'LEV33 QC @2b set JOB_STATUS = ',no_data_lines_nnn_status,' = no_data_lines_nnn_status';
    endif
    call wrtstd(prg,msg);
    go to 333   ! nlev==0 - skip to FINAL EVALUATION
endif
if(make_qcprof .or. make_ncprof)then
    write(msg,'("The number of levels is ",i4)')nlev; call wrtstd(prg,msg);
    call wrtstd(prg,SEPMNUS);
endif

if(DBLEV== 5)then; write(msg,'("QC05 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV== 5 .and. DBLEVEXIT) call dblev_exit("QC05")

!========================================================!
if(skip_profile_qctests)then
    if(DEBUG)then; write(msg,'("The profile does NOT need to go through the qc profile tests.")'); call wrtlog(prg,msg); endif
    go to 888; ! Go directly to write of META/TRAJ/TECH, skip PROF
endif
!========================================================!
!   7 Test  6 Gross check AKA Global Range Test                          !
!========================================================!
QCN='QC06'; QCTEST='Global Range Test            '
ret=qc06_gross_test(prg,P); write(msg,1000)QCN,"PRES",ret; call wrtlog(prg,msg);
if(hasTEMP(0))then; ret=qc06_gross_test(prg,T); write(msg,1000)QCN,"TEMP",ret; call wrtlog(prg,msg); endif
if(hasPSAL(0))then; ret=qc06_gross_test(prg,S); write(msg,1000)QCN,"PSAL",ret; call wrtlog(prg,msg); endif
if(hasDOXY(0))then; ret=qc06_gross_test(prg,O); write(msg,1000)QCN,"DOXY",ret; call wrtlog(prg,msg); endif
if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif

call evaluate_qcresult(QCN);

1000 format("QC Test ",a," for ",a," returns ",i2);
2001 format("RSLT qcp mid ",a,"  P: ",8i3,"  T: ",4i3,"  S: ",8i3)

if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC06 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(DBLEV== 6 .and. DBLEVEXIT) call dblev_exit("QC06")
!========================================================!
!   8 Test  7 Regional Range Test                        !
!========================================================!
! first, test to see if you need to run the regional test
QCN='QC07'; QCTEST='Regional Range Test          '
!lat=prof_LATITUDE; lon=prof_LONGITUDE;
!Note: As the new function has the variable type as - double, we may not need lat & lon of type - real.
! USE REAL LAT/LON call is_profile_regional(prof_LATITUDE,prof_LONGITUDE); ! This sub is in qc07_regional_test.f90
call is_profile_regional(real_LATITUDE,real_LONGITUDE); ! This sub is in qc07_regional_test.f90
if(DBLEV== 7)then; write(msg,*)'do_regional_test is: ',do_regional_test; call wrtdbg(prg,msg); endif	! DBG LEV06
if(do_regional_test)then
    write(msg,'("This is in the ",a3," region.")')sea; call wrttrc(prg,msg);
    ret=qc07_regional_test(prg,T);
    ret=qc07_regional_test(prg,S);
endif

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC07 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(DBLEV== 7)then; write(msg,'("QC07 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV== 7 .and. DBLEVEXIT) call dblev_exit("QC07")

! Evaluate flags for all parameters
call evaluate_pres_flags("after qc07/regional");
call evaluate_data_flags( 7,"after qc07/regional");

!========================================================!
!   9 Test  8 Pressure Increasing Test                   !
!========================================================!
QCN='QC08'; QCTEST='Pressure Increasing Test     '
ret=qc08_pres_increase(prg,P); write(msg,1000)QCN,"PRES",ret; call wrtlog(prg,msg);
call evaluate_qcresult(QCN);
if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC08 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif
if(DBLEV== 8)then; write(msg,'("QC08 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV== 8 .and. DBLEVEXIT) call dblev_exit("QC08")
call evaluate_pres_flags("after qc08/pres inc");

!========================================================!
!  10 Test  9 Spike Check Test                           !
!========================================================!
QCN='QC09a'; QCTEST='Spike Check Test             '
ret=qc09_spike_test(prg,T);
ret=qc09_spike_test(prg,S);
ret=qc09_spike_test(prg,O); 

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC09a",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif


call evaluate_data_flags( 9,"after qc09/spike check #1"); !CS added "#1"

QCN='QC09b'; QCTEST='Spike Check Test             '
ret=qc09_spike_test(prg,T); !CS added second round for spike test
ret=qc09_spike_test(prg,S); !CS added second round for spike test
ret=qc09_spike_test(prg,O); !CS added second round for spike test

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC09b",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif
call evaluate_data_flags( 9,"after qc09/spike check #2"); !CS added second round for spike test

if(DBLEV== 9)then; write(msg,'("QC09 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV== 9 .and. DBLEVEXIT) call dblev_exit("QC09")
!========================================================!
!  11 Test 10 Top and Bottom Spike Test : removed        !
!========================================================!
QCN='QC10'; QCTEST='Bottom Spike Test             '
! This test is NOT USED ret=qc10_bottom_spike_test();
! QCTEST_FLAG(iprf,1) is set to 1 in initialize_arrays
!========================================================!
!  12 Test 11 Gradient Test
!========================================================!
QCN='QC11a'; QCTEST='Gradient Test                '
ret=qc11_gradient_test(prg,T);
ret=qc11_gradient_test(prg,S);
if(hasDOXY(0)) ret=qc11_gradient_test(prg,O);

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC11a ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(DBLEV==11)then; write(msg,'("QC11 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==11 .and. DBLEVEXIT) call dblev_exit("QC11")

call evaluate_data_flags(11,"after qc11/gradient #1"); !CS added "#1"

QCN='QC11b'; QCTEST='Gradient Test                '
ret=qc11_gradient_test(prg,T); !CS added second round for gradient test
ret=qc11_gradient_test(prg,S); !CS added second round for gradient test
if(hasDOXY(0)) ret=qc11_gradient_test(prg,O); !CS added second round for gradient test

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC11b ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif
call evaluate_data_flags(11,"after qc11/gradient #2"); !CS added second round for gradient test

if(DBLEV==11 .and. DBLEVEXIT) call dblev_exit("QC11")
!========================================================!
!  13 Test 12 Digit Rollover Test                        !
!========================================================!
QCN='QC12'; QCTEST='Digit Rollover Test          '
! This test is done in the decoder stage

!========================================================!
!  14 Test 13 Stuck Value Test  AKA, constant value      !
!========================================================!
QCN='QC13'; QCTEST='Stuck Value Test             '
STUCK_T=qc13_stuck_value(prg,T(1),t1r);
STUCK_S=qc13_stuck_value(prg,S(1),s1r);
! if(STUCK_S > 1)then if(do_psal_adj) 
! 28May2015 - do for ALL non-near-surface profiles (quick/easy way to add this)
if(.not. near_surface(2))then
    if(hasDATA(t2r)) STUCK_T=qc13_stuck_value(prg,T(1),t2r);
    if(hasDATA(s2r)) STUCK_S=qc13_stuck_value(prg,S(1),s2r);
endif
if(.not. near_surface(3))then
    if(hasDATA(t3r)) STUCK_T=qc13_stuck_value(prg,T(1),t3r);
    if(hasDATA(s3r)) STUCK_S=qc13_stuck_value(prg,S(1),s3r);
endif    
if(.not. near_surface(4))then
    if(hasDATA(t4r)) STUCK_T=qc13_stuck_value(prg,T(1),t4r);
    if(hasDATA(s4r)) STUCK_S=qc13_stuck_value(prg,S(1),s4r);
endif    
if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC13 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(hasDOXY(0)) STUCK_O=qc13_stuck_value(prg,O(1),do1);

if(DBLEV==13)then; write(msg,'("QC13 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==13 .and. DBLEVEXIT) call dblev_exit("QC13")
!========================================================!
!  15 Test 14 Density Inversion Test                     !
!========================================================!
! FIX KLUGE ALERT FIX KLUGE ALERT FIX KLUGE ALERT FIX FIX QCN='QC14'; QCTEST='Density Inversion Test       '
ret = 0;        ! default to "cannot be performed"
if(hasDATA(p1r) .and. hasDATA(t1r) .and. hasDATA(s1r) .and. .not.near_surface(1))then
    if(DBLEV==14)then; write(msg,'("QC+ calls QC14 foa p1r,t1r,s1r")'); call wrtdbg(prg,msg); endif
    ret=qc14_density_inversion(prg,p1r,t1r,s1r);  ! location of PRIMARY profile parameters, REG fields
    if(do_psal_adj)then;
	write(msg,'("QC+ calls QC14 foa p1a,t1r,s1a")'); call wrtdbg(prg,msg);
	ret=qc14_density_inversion(prg,p1r,t1r,s1a);  ! location of PRIMARY profile parameters, ADJ fields
    endif
endif
if(hasDATA(p2r) .and. hasDATA(t2r) .and. hasDATA(s2r) .and. .not.near_surface(2))then
    write(msg,'("QC+ calls QC14 is for p2r,t2r,s2r")'); call wrtdbg(prg,msg);
    ret=qc14_density_inversion(prg,p2r,t2r,s2r);  ! location of SECONDARY profile parameters, REG fields
    if(do_psal_adj)then;
        write(msg,'("QC+ calls QC14 foa p2a,t2r,s2a")'); call wrtdbg(prg,msg);
        ret=qc14_density_inversion(prg,p2a,t2r,s2a);  ! location of SECONDARY profile parameters, ADJ fields
    endif
endif
if(hasDATA(p3r) .and. hasDATA(t3r) .and. hasDATA(s3r) .and. .not.near_surface(3))then
    write(msg,'("QC+ calls QC14 is for p3r,t3r,s3r")'); call wrtdbg(prg,msg);
    ret=qc14_density_inversion(prg,p3r,t3r,s3r);  ! location of SECONDARY profile parameters, REG fields
    if(do_psal_adj)then;
        write(msg,'("QC+ calls QC14 foa p3a,t3r,s3a")'); call wrtdbg(prg,msg);
        ret=qc14_density_inversion(prg,p3a,t3r,s3a);  ! location of SECONDARY profile parameters, ADJ fields
    endif
endif
if(hasDATA(p4r) .and. hasDATA(t4r) .and. hasDATA(s4r) .and. .not.near_surface(4))then
    write(msg,'("QC+ calls QC14 is for p4r,t4r,s4r")'); call wrtdbg(prg,msg);
    ret=qc14_density_inversion(prg,p4r,t4r,s4r);  ! location of SECONDARY profile parameters, REG fields
    if(do_psal_adj)then;
        write(msg,'("QC+ calls QC14 foa p4a,t4r,s4a")'); call wrtdbg(prg,msg);
        ret=qc14_density_inversion(prg,p4a,t4r,s4a);  ! location of SECONDARY profile parameters, ADJ fields
    endif
endif

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC14 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(DBLEV==14)then; write(msg,'("QC14 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==14 .and. DBLEVEXIT) call dblev_exit("QC14")

call evaluate_data_flags(14,"after qc14/deninv")

!========================================================!
!  16 Test 15 Grey List Test                             !
!========================================================!
QCN='QC15'; QCTEST=' Grey List Test              '
ret=qc15_grey_list(prg,P,T,S,O);

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC15 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(DBLEV==15)then; write(msg,'("QC15 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==15 .and. DBLEVEXIT) call dblev_exit("QC15")
!========================================================!
!  17 Test 16 Gross salinity or temperature sensor drift !
!========================================================!
! Note that this is returned like an ndicator, but is then translated into a flag
QCN='QC16'; QCTEST='Gross sensor drift Test      '
JUMPC_T=qc16_jump_check(prg,p1r,T);
if(DBLEV==16)then; write(msg,*)'JUMP_CHECK FLAG for T has returned: ',JUMPC_T; call wrtdbg(prg,msg); endif
JUMPC_S=qc16_jump_check(prg,p1r,S);
if(DBLEV==16)then; write(msg,*)'JUMP_CHECK FLAG for S has returned: ',JUMPC_S; call wrtdbg(prg,msg); endif

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC16 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif
if(DBLEV==16)then; write(msg,'("QC16 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==16 .and. DBLEVEXIT) call dblev_exit("QC16")
!========================================================!
!  xx Test 17 Visual QC - not performed here             !
!========================================================!
! Do NOT evaluate hold_qctest
!========================================================!
!  18 Test 18 Frozen profile Test                        !
!========================================================!
QCN='QC18'; QCTEST='Frozen profile Test          '

FROZN_T=qc18_frozen_profile(prg,T);
if(DEBUG)then; write(msg,'("QC18 returns FROZN_T: ",i2)')FROZN_T; call wrtdbg(prg,msg); endif
FROZN_S=qc18_frozen_profile(prg,S);
if(DEBUG)then; write(msg,'("QC18 returns FROZN_S: ",i2)')FROZN_S; call wrtdbg(prg,msg); endif
1010 format(i4,f12.2,i3)
if(DBLEV==18)then;
    write(msg,*)'qcplus temp/psal_is_frozen: ',temp_is_frozen,psal_is_frozen; call wrtdbg(prg,msg);
endif

! See if we have both temp * psal frozen - if so, see if the TESAC file is requested
if(temp_is_frozen .and. psal_is_frozen)then;
    write(msg,'("QC+ - both TEMP & PSAL are frozen")')
    if(frozen_profile_rule == 1)then;
	write(msg,'(a," - frozen_profile_rule is 1, use the Gilson method")')trim(msg)
	if(make_tesac)then;
	    make_tesac = .false.;
	    write(msg,'("Both TEMP & PSAL are frozen, RULE=1, do NOT send data to TESAC")');
	    call wrttrc(prg,msg);
	endif
    else
	write(msg,'(a," - frozen_profile_rule is 0, trant as usual")')trim(msg)
    endif
elseif(temp_is_frozen .or. psal_is_frozen)then;
    if(temp_is_frozen)then;
	write(msg,'("QC+ - TEMP is frozen")')
    else
	write(msg,'("QC+ - PSAL is frozen")')
    endif
    if(frozen_profile_rule == 1)then;
	write(msg,'(a," - frozen_profile_rule is 1, use the Gilson method")')trim(msg)
    else
	write(msg,'(a," - frozen_profile_rule is 0, trant as usual")')trim(msg)
    endif
    call wrttrc(prg,msg)
    if(DBLEV==18)then; call wrtdbg(prg,msg); endif
endif

if(FROZN_T==IND_ON .or. FROZN_S==IND_ON)then; ret=FAIL; else; ret=PASS; endif

call evaluate_qcresult(QCN);

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC18 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif

if(DBLEV==18)then; write(msg,'("QC18 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==18 .and. DBLEVEXIT) call dblev_exit("QC18")
!========================================================!
! NST TESTING
!========================================================!
!  19 Test 21 Near_surface unpumped salinity test
!========================================================!
! This is called for STS profiles - near-surface unpumped CTD
! The test is only for PROVOR/NOVA floats with n_prof>1 - we have none as of May 2015
QCN='QC21'; QCTEST='FNear_surf psal              '
! NOT_USED if(STS_prof(0))then
! NOT_USED     if(DEBUG)then; write(msg,'("QC+ calls qc21 because there are STS profiles")'); call wrtdbg(prg,msg); endif
! NOT_USED     ret=qc21_ns_unpumped_ctd(prg,S);
! NOT_USED else
! NOT_USED     if(DEBUG)then; write(msg,'("QC+ omits qc21 because there are NO STS profiles")'); call wrtdbg(prg,msg); endif
! NOT_USED endif

! NOT_USED if(DBLEV==21)then; write(msg,'("QC21 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
! NOT_USED if(DBLEV==21 .and. DBLEVEXIT) call dblev_exit("QC21")
!========================================================!
!========================================================!
!  20!Test 22 Near_surfac mixed air/water
!========================================================!
! This is called for NST profiles - near-surf. temp, no psal presnet
QCN='QC22'; QCTEST='FNear_surf pres              '
near_surface(0) = .false.; ! FIX NEEDED - STS/NST not yet working
if(near_surface(0))then
    if(DEBUG)then; write(msg,'("NEAR SURF qcplus calls qc22 near_surface profile is present")'); call wrtdbg(prg,msg); endif
    ! FIX - make funcitonal later ret=qc22_ns_mixed_air_water(prg);
    if(DEBUG)then; write(msg,'("NEAR SURF qcplus rtrns qc22, ret: ",i2)')ret; call wrtdbg(prg,msg); endif
else
    if(DEBUG)then; write(msg,'("NEAR SURF qcplus omits qc22 NO near_surface profiles are resent")'); call wrtdbg(prg,msg); endif
endif

if(DBLEV > 0)then; write(msg,2001)QCN,(qcdataresult(i),i=1,20); call wrtdbg(prg,msg); qcdataresult=-1; endif
if(DBLEV== 1)then; do iprf=1,nprf; write(msg,1002)"QC22 ",iprf,(QCTEST_FLAG(iprf,i),i=1,nt); enddo; call wrtdbg(prg,msg); endif
if(DBLEV==22)then; write(msg,'("QC22 returns: ",i3)')ret; call wrtdbg(prg,msg); endif
if(DBLEV==22 .and. DBLEVEXIT) call dblev_exit("QC22")
!========================================================!

! 13May 14, un-numbered test/filter for any DEEP_ARGO_FLOAT
if(DEEP_ARGO_FLOAT)then
    if(DEBUG)then; write(msg,*)'This is a DEEP_ARGO float, flag points below 2000db'; call wrtdbg(prg,msg); endif
    do ilev=1,nlev
	if(profdata(p1r,ilev) > 2000.0) exit;	! exit the loop, not the program
	tlev = ilev;				! save for later
    enddo
    if(tlev < nlev)then ! we go deeper than 2000db
	do idat=P(2),P(3);		! pres first
	    if(hasDATA(idat))then
		do ilev=tlev,nlev
		    if(profflag(idat,ilev) < 2) profflag(idat,ilev) = 2; ! DeepARGO, below 2000db PRES/PRESADJ qc=2
		enddo
	    endif
	enddo
	do idat=T(2),T(3);              ! temp next
	    if(hasDATA(idat))then 
		do ilev=tlev,nlev
		    if(profflag(idat,ilev) < 2) profflag(idat,ilev) = 2; ! DeepARGO, below 2000db TEMP/TEMPADJ qc=2
		enddo
	    endif
	enddo
        do idat=S(2),S(3);              ! psal last
	    if(hasDATA(idat))then
		do ilev=tlev,nlev
		    if(profflag(idat,ilev) < 3) profflag(idat,ilev) = 3; ! DeepARGO, below 2000db PSAL/PSALADJ qc=3
		enddo
	    endif
	enddo
    endif
endif
!========================================================!
! OLD !     Test a1 AOML Climatology Test                      !
! OLD !========================================================!
! OLD QCN='QCa1'; QCTEST='Climatology Test       '
! OLD if(only_tesac)then
! OLD     write(msg,'("I only_tesac is true, do not run the Climatology Test")');
! OLD     call wrttrc(prg,msg);
! OLD else
! OLD     ret=qca1_climatology(prg,T);
! OLD     ret=qca1_climatology(prg,S);
! OLD endif
! OLD 
! OLD !========================================================!
! OLD !     Test a2 AOML Analysis Test                         !
! OLD !========================================================!
! OLD QCN='QCa2'; QCTEST='Analysis Test           '
! OLD ret=qca2_analysis(prg,T);
! OLD ret=qca2_analysis(prg,S);
! OLD 
! OLD ! If nlev==0, the JOB_STATUS has already been set accoringly, and then jumps this section.
! OLD ! Set the JOB_STATUS to GOOD - test the various failure cases. (incomplete/failure, etc.)
! OLD ! If none of these reset JOB_STATUS, we are goo to go
! OLD JOB_STATUS = GOOD;
! OLD if(DEBUG) write(DBG,'("JOB_ST PROF @3 Set JOB_STATUS: ",i2,"GOOD ")')JOB_STATUS 
!========================================================!
333 continue		! Come here to skip to FINAL EVALUATION
!========================================================!
if(DEBUG)then;
    write(msg,'("====== Tests COMPLETED, proceed to EVALUATION =====")');	! DBG
    call wrtdbg(prg,msg);                                                       ! DBG
endif

! If any levels failed the deepest pres case, mark TEMP & PSAL also as bad
if(qc19_result > 2)then
    if(DEBUG)then; write(msg,'("QC19 I QC19_result is > 2, mark TEMP & PSAL")'); call wrtlog(prg,msg); endif
    call evaluate_qc19_flags(prg)
endif

! Are there any near_surface profles that were tested?
if(near_surface_result >= PROB_BAD)then
    ! FIX - make funcitonal later call evaluate_qc22_flags(prg);
endif

! All qc tests are done, evaluate pres/data flags one last time
call evaluate_pres_flags("final evaluation Pxxx");		! This evaluates only profflag wrt testflag by level
call evaluate_data_flags(22,"final evaluation TSOx");		! This evaluates only profflag wrt testflag byu level

! Now do the final evaluateion: profile_<>_qc, and overall profile flags

call evaluate_final_flags("final flag evaluation");		! This evaluates profile_<>_qc, and column flags
call evaluate_job_flags()

! Are there any near_surface profles that were tested?
if(near_surface_result >= PROB_BAD)then
    ! FIX - make funcitonal later call evaluate_qc22_flags(prg);
endif
if(DEBUG)then;
    write(msg,'("====== EVALUATION COMPLETED, proceed to OUTPUT =====")');	! DBG
    call wrtdbg(prg,msg);                                                       ! DBG
endif										! DBG

! Fill out the nc variables that have not yet been filled

chr_DC_REFERENCE = profile(1:4);! unique identifier in data centre - changed 20160502 to aomlid only
chr_DATA_MODE = 'R'; if(do_pres_adj .or. do_psal_adj) chr_DATA_MODE = 'A';

!----------------------------------------------------------------------
! Weird check to mke sure that lat/lon is correct - I had a bug that
! started this, but there have also been problems in the pase - a PI
! was mistakinly putting 0.0 as lat and lon on some new floats.
! TEST LAT=LON prof_LATITUDE = prof_LONGITUDE; ! TEST
! TEST LAT=LON write(msg,'("QC+ SPECIAL TEST set prof_LATITUDE = prof_LONGITUDE")'); call wrtdbg(prg,msg);
if(prof_LATITUDE == prof_LONGITUDE .and. prof_LATITUDE/=FILLPOSN)then
    if(DBLEV==97)then;		! Special case lat really is == lon, process it
	write(wrnmsg,'("WARNING 104 LEV=87, special test, force processing when LAT==LON")'); ! WRN
	call warning(prg,104,wrnmsg); ! WARNING 104 in qcplus ! WRN
    else
	write(errmsg(4),'("NON-FATAL ERROR 210 profile: ",a)')trim(profile)
	write(errmsg(1),'("NON-FATAL ERROR 210 prof_LATITUDE == prof_LONGITUDE detectred")')
	write(errmsg(2),*)'NON-FATAL ERROR 210 prof_LATITUDE  = ',prof_LATITUDE
	write(errmsg(3),*)'NON-FATAL ERROR 210 prof_LONGITUDE = ',prof_LONGITUDE
	call error_report(prg,210,4,errmsg); ! QC+ LAT==LON
    endif
endif

! ============================================================================================
! Format statements for FILMSG reporting
3001 format("QCPLUS FILMSG ",a," filmsg @",i1," in qcplus"," calls ",a);
3002 format("QCPLUS FILMSG ",a," filmsg @",i1," in qcplus"," rtrns ",a);
3003 format("QCPLUS FILMSG ",a," filmsg @",i1," in qcplus"," after ",a);
! ============================================================================================
! Write out the qcprof file if needed
if(make_qcprof)then;
    WRTFILE = 'QCPROF'; WRTINDX = 1;
    if(DEBUG) write(DBG,'("QC+ calls write_qcprof for file: ",a)')trim(pathname_qcprof);
    call wrtflm(prg,'call write_qcprof');
    result_qcprof = write_qcprof(qcplus_version,pathname_qcprof);
    call wrtflm(prg,'rtrn write_qcprof');
    if(DEBUG) write(DBG,'("QC+ rtrns write_qcprof with the result: ",a)')result_qcprof
    write(msg,3003)filmsg,1,'write_qcprof'; call wrtlog(prg,msg);    
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif
if(DBLEV==36 .and. DBLEVEXIT)then; call dblev_exit("after qcprof"); endif
!------------------------------------------------------------------------------
if(DEBUG)then
     write(DBG,'("QC+ PPQC_ZM prof_pres_qc: ",4a3)')prof_pres_qc; ! DBG
     write(DBG,'("QC+ PPQC_ZM prof_temp_qc: ",4a3)')prof_temp_qc; ! DBG
     write(DBG,'("QC+ PPQC_ZM prof_psal_qc: ",4a3)')prof_psal_qc; ! DBG
endif
do iprf=1,nprf
     if(prof_pres_qc(iprf) == 'Z') zerlines_Z_failure = .true.;
     if(prof_temp_qc(iprf) == 'Z') zerlines_Z_failure = .true.;
     if(prof_psal_qc(iprf) == 'Z') zerlines_Z_failure = .true.;
     if(prof_pres_qc(iprf) == 'Z') prof_pres_qc(iprf) = ' ';
     if(prof_temp_qc(iprf) == 'Z') prof_temp_qc(iprf) = ' ';
     if(prof_psal_qc(iprf) == 'Z') prof_psal_qc(iprf) = ' ';
enddo
if(zerlines_Z_failure)then
    if(DEBUG) write(DBG,'("PPQC_ZM An invalid grade of Z was detected")');
    write(errmsg(6),'("NON-FATAL ERROR 217 in qcplus for profile: ",a)') trim(profinp);
    write(errmsg(1),'("NON-FATAL ERROR 217 A grade of Z was found for a prof_<>_qc")')
    write(errmsg(2),'("NON-FATAL ERROR 217 Grades for prof_pres__qc: ",4a3)')prof_pres_qc;
    write(errmsg(3),'("NON-FATAL ERROR 217 Grades for prof_temp__qc: ",4a3)')prof_temp_qc;
    write(errmsg(4),'("NON-FATAL ERROR 217 Grades for prof_psal__qc: ",4a3)')prof_psal_qc;
    write(errmsg(5),'("NON-FATAL ERROR 217 The Z is retained in the qc file, but is changed to blank in the nc R0file")')
else
    if(DEBUG) write(DBG,'("PPQC_ZM All grades were valid")');
endif
! ==================================================================================
! See the various cases, and find out if we need to write to the tesac file

rightnow_JULD = get_utc_juld()
if(make_tesac)then
    if(nlev==0)then
        write(msg,'("This profile has zero lines, so will NOT be send to the GTS.")'); call wrtstd(prg,msg);
        make_tesac = .false.
        result_tesac = 'z'; filmsg(8:8) = 'z'; call wrtflm(prg,'nlev=0, do not make the tesac file');
    elseif(nlev==1)then
        write(msg,'("This profile has one line, so will NOT be send to the GTS.")'); call wrtstd(prg,msg);
        make_tesac = .false.
        result_tesac = '1'; filmsg(8:8) = '1'; call wrtflm(prg,'nlev=1, do not make tesac file');
    elseif(date_flag /= 1)then;
        write(msg,'("The date flag is ",i1," so this profile will NOT be send to the GTS, ",a)')date_flag; call wrtstd(prg,msg);
        make_tesac = .false.
        result_tesac = 'n'; filmsg(8:8) = 'n'; call wrtflm(prg,'profile does not have a good date');
    elseif(posn_flag /= 1 .and. posn_flag /= 8)then;
        write(msg,'("The posn flag is ",i1," so this profile will NOT be send to the GTS, ")')posn_flag; call wrtstd(prg,msg);
        make_tesac = .false.
        result_tesac = 'n'; filmsg(8:8) = 'n'; call wrtflm(prg,'profile does not have a good date');
    elseif(rightnow_JULD-prof_JULD >30) then
        write(msg,'("This profile too old, so will NOT be send to the GTS, ")'); call wrtstd(prg,msg);
        make_tesac = .false.
        result_tesac = 'o'; filmsg(8:8) = 'o'; call wrtflm(prg,'The profile is too old');
    elseif(zerolines1 .or. cksm_bad)then
        ! get the minimum time delay for deciding what to do with profiles that have gaps or failed a CRC test in the profile.  If a
        ! profile (prof_JULD) is older than now (rightnow_JULD) - TIME_EXEC2GTSFORMAT (in hours) it gets send unless it is too old
        call get_default_envvar(prg,"TIME_EXEC2GTSFORMAT",chr8);
        read(chr8,*)TIME_EXEC2GTSFORMAT;        ! maximum wait time to send incomplete profiles to GTS
        if(DEBUG)then
            write(msg,*)' '; call wrtdbg(prg,msg);      ! skip a line                                   ! DBG
            write(msg,'("  The profile JULD is ",f18.12)')prof_JULD; call wrtdbg(prg,msg);              ! DBG
            write(msg,'("Rightnow, the JULD is ",f18.12)')rightnow_JULD; call wrtdbg(prg,msg);          ! DBG
            write(msg,*)' '; call wrtdbg(prg,msg);      ! skip a line                                   ! DBG
        endif
        if(rightnow_JULD-prof_JULD <= TIME_EXEC2GTSFORMAT/24.0)then
            ! We HAVE NOT waited long enough to send this profile to GTS
            msg = 'We have not wited long enough';
            if(zerolines1) write(msg,'(a,", zerolines1 is true")')trim(msg)
            if(cksm_bad)   write(msg,'(a,", cksm_bad is true")')trim(msg)
            write(msg,'(a," - change result_tesac to Wait")')trim(msg); call wrtstd(prg,msg);
            make_tesac = .false.
            result_tesac = "w"; filmsg(8:8) = 'w'; call wrtflm(prg,'result_tesac = w for zerolines1 or checksum error');
        endif
    endif
    if(make_tesac)then; write(msg,'(a," TESAC ")')trim(msg); call wrttrc(prg,msg); endif
else
    result_tesac = 'n'; filmsg(8:8) = 'n'; call wrtflm(prg,'TESAC The tesac file was not requested');
endif   ! if(make_tesac)
call wrtlog(prg,msg); ! TESAC line 1
if(DEBUG) write(DBG,*)'TESAC DBG After flag evaluation, make_tesac: ',make_tesac,' result_tesac: ',result_tesac; ! DBG
if(make_tesac)then
    WRTFILE = 'TESAC '; WRTINDX = LTSAC;
    if(nlev == 0)then
        write(tmp,'("write_tesac not called, ZERO levels")')
        call wrtflm(prg,'write_tesac is NOT called, nlev=zero');
        result_tesac =  'z'; filmsg(l:l) = 'z'; call wrtflm(prg,'z = nlev == 0');
        make_tesac = .false.;
    else
	call wrtflm(prg,'call write_tesac');
	! OLD result_tesac = write_tesac(pathname_tesac);
	result_tesac = 'n'; ! OLD PURGE LATER
	filmsg(8:8) = result_tesac; call wrtflm(prg,'set to result_tesac after result_tesac');
	call wrtflm(prg,'rtrn write_tesac');
    endif
    write(msg,3003)filmsg,2,'write_tesac '; call wrtlog(prg,msg);    
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif
! ========================================================================================
!----------------------------------------------------------------------
! Write out the ncprof file if needed
result_ncprof = '?';
if(make_ncprof)then
    WRTFILE = 'NCPROF'; WRTINDX = 2;
    if(nlev == 0)then
	write(tmp,'("write_ncprof not called, ZERO levels")')
	call wrtflm(prg,'write_ncprof is NOT called, nlev=zero');
	result_ncprof =  'z'; filmsg(LNC:LNC) = 'z';
	make_ncprof = .false.;
	if(make_ncbiop)then;
	    write(tmp,'("write_ncbiop not called, ZERO levels")')
	    call wrtflm(prg,'write_ncbiop is NOT called, nlev=zero');
	    result_ncbiop =  'z'; filmsg(LBIOP:LBIOP) = 'z';
	     make_ncbiop = .false.;
	endif
    else
	call wrtflm(prg,'call write_ncprof');
	if(DEBUG) write(DBG,'("DBG DOXY what is outRDOXY befreo write_ncprof: ",l2)')outRDOXY; 
	result_ncprof = write_ncprof(pathname_ncprof);
	call wrtflm(prg,'rtrn write_ncprof');
	write(tmp,'("write_ncprof called")');
	if(result_ncprof /= 'y')then;
	    tmp = trim(tmp) // ' returning NON-FATAL ERROR 210';
	    write(errmsg(3),'("NON-FATAL ERROR 210 profile: ",a)')trim(profile)
	    write(errmsg(2),'("NON-FATAL ERROR 210 3")');
	    write(errmsg(1),'("NON-FATAL ERROR 210 in qcplus bad result from write_ncprof: ",i3)')ret;
	    call error_report(prg,210,3,errmsg); ! bad result from write_ncprof
	endif
    endif
    write(msg,3003)filmsg,3,'write_ncprof'; call wrtlog(prg,msg);
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif
if(DBLEV==91 .and. DBLEVEXIT)then; call dblev_exit("after NCPROF"); endif
!----------------------------------------------------------------------
! Make the biop
if(make_ncbiop)then
    WRTFILE = 'NCBIOP'; WRTINDX = 6;
    call wrtflm(prg,'call write_ncbiop');
    result_ncbiop = write_ncbiop(pathname_ncbiop);
    call wrtflm(prg,'rtrn write_ncbiop');
    write(tmp,'("write_ncbiop called")');
    if(result_ncbiop /= 'y')then;
        tmp = trim(tmp) // ' returning NON-FATAL ERROR 211';
        write(errmsg(3),'("NON-FATAL ERROR 211 profile: ",a)')trim(profile)
	write(errmsg(2),'("NON-FATAL ERROR 211 4")');
        write(errmsg(1),'("NON-FATAL ERROR 211 in qcplus bad result from write_ncbiop: ",i3)')ret;
        call error_report(prg,211,3,errmsg); ! bad result from write_ncbiop
    endif
    write(msg,3003)filmsg,4,'write_ncbiop'; call wrtlog(prg,msg);    
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif

if(DBLEV==95 .and. DBLEVEXIT)then; call dblev_exit("after NCBIOP"); endif
!----------------------------------------------------------------------

! ========================================================================================
888 continue; ! Com here to skip all profile 
! ========================================================================================
! The qcprof & ncprof & ncbiop & tesac profile files have been created, it is now safe to 
! call read_all_qc and read ALL the qc files - previously, we were using the current qc file
! for the fronzen profile/jump checks. Dun.
!----------------------------------------------------------------------
if(make_ncmeta .or. make_nctraj .or. make_nctech)then
    if(DEBUG) write(DBG,'("QC+RNC EXT call gen_all_qc")')
    ret=get_all_qc(pathname_qcprof)
    if(DEBUG) write(DBG,'("QC+RNC EXT rtrn gen_all_qc")')
    if(DEBUG)then; write(msg,'("CRNC RDQ ALL return value from get_all_qc: ",i1)')ret; call wrtdbg(prg,msg); endif
endif
!----------------------------------------------------------------------
889 continue
if(make_ncmeta)then;
    write(DBG,'("QC+ DBG=",l1,"   meta_FORMAT_VERSION: ",a)')DEBUG,trim(meta_FORMAT_VERSION);     ! DBG
    write(DBG,'("QC+ DBG=",l1,"      meta_USER_MANUAL: ",a)')DEBUG,trim(meta_USER_MANUAL);         ! DBG
    write(DBG,'("QC+ DBG=",l1,"     meta_cycnum_cnvnt: ",a)')DEBUG,meta_cycnum_conventions(1:16); ! DBG
endif

if(make_ncmeta)then
    WRTFILE = 'NCMETA'; WRTINDX = 3;
    call wrtflm(prg,'call write_ncmeta');
    result_ncmeta = write_ncmeta(pathname_ncmeta);
    call wrtflm(prg,'rtrn write_ncmeta');
    write(tmp,'("write_ncmeta called")');
    if(result_ncmeta /= 'y')then;
        tmp = trim(tmp) // ' returning NON-FATAL ERROR 212';
        write(errmsg(3),'("NON-FATAL ERROR 212 profile: ",a)')trim(profile)
	write(errmsg(2),'("NON-FATAL ERROR 212 7")')
        write(errmsg(1),'("NON-FATAL ERROR 212 in qcplus bad result from write_ncmeta: ",i3)')ret;
        call error_report(prg,212,3,errmsg); ! bad result from write_ncmeta
    endif
    write(msg,3003)filmsg,5,'write_ncmeta'; call wrtlog(prg,msg);    
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif

if(DBLEV==92 .and. DBLEVEXIT)then; call dblev_exit("after NCMETA"); endif
!----------------------------------------------------------------------
! Write out the tech.nc file if needed
if(make_nctech)then;
    if(DEBUG) write(DBG,'("QC+ NCTECH DBG=",l1,"   prof_FORMAT_VERSION: ",a)')DEBUG,trim(prof_FORMAT_VERSION);     ! DBG
    if(DEBUG) write(DBG,'("QC+ NCTECH DBG=",l1,"      prof_USER_MANUAL: ",a)')DEBUG,trim(prof_USER_MANUAL);         ! DBG
    if(DEBUG) write(DBG,'("QC+ NCTECH DBG=",l1,"     tech_cycnum_cnvnt: ",a)')DEBUG,tech_cycnum_conventions(1:16) ! DBG
    WRTFILE = 'NCTECH'; WRTINDX = 4;
    pathname_nctech = trim(pathname_ncdir) // trim(wmoid) // "_tech.nc"
	write(tmp,'("QC+ about to call write_nctech")')
    call wrtflm(prg,'call write_nctech');
    result_nctech = write_nctech(pathname_nctech);
    call wrtflm(prg,'rtrn write_nctech');
    if(result_nctech /= 'y')then;
        tmp = trim(tmp) // ' returning NON-FATAL ERROR 213';
        write(errmsg(3),'("NON-FATAL ERROR 213 profile: ",a)')trim(profile)
	write(errmsg(2),'("NON-FATAL ERROR 213 5")');
        write(errmsg(1),'("NON-FATAL ERROR 213 bad result from write_nctech: ",i3)')ret;
        call error_report(prg,213,3,errmsg); ! bad result from write_nctech
    endif
    write(msg,3003)filmsg,6,'write_nctech'; call wrtlog(prg,msg);    
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif

if(DBLEV==94 .and. DBLEVEXIT)then; call dblev_exit("after NCTECH"); endif                                                    ! DBG LEV94

!----------------------------------------------------------------------
if(make_nctraj)then;
    if(DEBUG) write(DBG,'("QC+ NCTRAJ DBG=",l1,"   prof_FORMAT_VERSION: ",a)')DEBUG,trim(prof_FORMAT_VERSION);     ! DBG
    if(DEBUG) write(DBG,'("QC+ NCTRAJ DBG=",l1,"      prof_USER_MANUAL: ",a)')DEBUG,trim(prof_USER_MANUAL);         ! DBG
    if(DEBUG) write(DBG,'("QC+ NCTRAJ DBG=",l1,"     traj_cycnum_cnvnt: ",a)')DEBUG,traj_cycnum_conventions(1:16) ! DBG
    WRTFILE = 'NCTRAJ'; WRTINDX = 5;
    ret=qc20_quest_argos_posn(prg);
    call wrtflm(prg,'call write_nctraj');
    result_nctraj = write_nctraj(pathname_nctraj);
    call wrtflm(prg,'rtrn write_nctraj');
    write(tmp,'("write_nctraj called")');
    if(result_nctraj /= 'y')then;
        tmp = trim(tmp) // ' returning NON-FATAL ERROR 214';
        write(errmsg(3),'("NON-FATAL ERROR 214 profile: ",a)')trim(profile)
	write(errmsg(2),'("NON-FATAL ERROR 214 8")');
        write(errmsg(1),'("NON-FATAL ERROR 214 in qcplus bad result from write_nctraj: ",i3)')ret;
        call error_report(prg,214,3,errmsg); ! bad result from write_nctraj
    endif
    write(msg,3003)filmsg,7,'write_nctraj'; call wrtlog(prg,msg);    
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif
if(DBLEV==93 .and. DBLEVEXIT)then; call dblev_exit("after NCTRAJ"); endif
!----------------------------------------------------------------------
! Pretend to make the biot
if(make_ncbiot)then
    WRTFILE = 'NCBIOT'; WRTINDX = 7;
    call wrtflm(prg,'call write_ncbiot');
    result_ncbiot = write_ncbiot(pathname_ncbiot);
    call wrtflm(prg,'rtrn write_ncbiot');
    write(tmp,'("write_ncbiot called")');
    if(result_nctraj /= 'y')then;
        tmp = trim(tmp) // ' returning NON-FATAL ERROR 215';
        write(errmsg(3),'("NON-FATAL ERROR 215 profile: ",a)')trim(profile)
	write(errmsg(2),'("NON-FATAL ERROR 215 6")');
        write(errmsg(1),'("NON-FATAL ERROR 215 in qcplus bad result from write_ncbiot: ",i3)')ret;
        call error_report(prg,215,3,errmsg); ! bad result from write_ncbiot
    endif
    write(msg,3003)filmsg,8,'write_ncbiot'; call wrtlog(prg,msg);    
    WRTFILE = 'QCPLUS'; WRTINDX = 0; ! The write routine is done, control returns to QCPLUS
endif

if(DBLEV==96 .and. DBLEVEXIT)then; call dblev_exit("after NCBIOT"); endif
if(dbgnc_exit_after_all_ncwrites)then; call dblev_exit("after ALL write_nc"); endif
!----------------------------------------------------------------------

! create output line for ftpgts file IF the file was added to the gts file
if(make_tesac)then
    if(result_tesac == "y")then
	write(ftpmsg,'(a," ",a,a8,2f8.2," ",i4,"/",i2.2,"/",i2.2," ",i2.2,":",i2.2)')trim(filename_tesac), &
	    trim(profile), trim(wmoid),real_LATITUDE,real_LONGITUDE,iyr,imo,idy,ihh,imn
	call add_ftpgtsline()
	write(msg,'("FTPGTS: ",a)')trim(ftpmsg); call wrtstd(prg,msg);
    else
	write(msg,'("FTPGTS: result is not y, do not add a line to the ftpgts file")'); call wrtstd(prg,msg);
    endif
endif
!----------------------------------------------------------------------
! create outpuline for 2tesac file (PHY2GTSFMT_TABLE)
if(result_tesac /= 'o' .and. send_to_GTS)then
    if(result_tesac .eq. "w")then
        complete2tesac = "w"
        make2tesac = 'n'
    elseif(result_tesac .eq. "y")then
        complete2tesac = "y"
        make2tesac = 'y'
    else
        complete2tesac = "n"
        make2tesac = 'n'
    endif

   write(tesmsg,'(a,a,a7,i4,"/",i2.2,"/",i2.2," ",i2.2,":",i2.2,a6,a11 )')trim(profile),".qc","       ", &
        JULD_year, JULD_mon,JULD_day, JULD_hr, JULD_mn,complete2tesac,make2tesac
         ! this is from juld_locaton wrongo iyr,imo,idy,ihh,imn,complete2tesac,make2tesac

   call add_2tesacline(); ! Note that we need this regardless of the result from make_tesac
   write(msg,'("TESGTS: ",a)')trim(tesmsg); call wrtstd(prg,msg);
else
    if(DEBUG)then; write(msg,'("TESAC result_tesac=o, so  ",a," is an old profile")')trim(profile); call wrtlog(prg,msg); endif
endif

!----------------------------------------------------------------------
!
! File production all done
!
!----------------------------------------------------------------------

maxflag = maxprfflag(1); ! max flag for all parameters for PRIMARY profile

if(zerolines1 .or. cksm_bad)then		! ZERO_LINES were detected, exit with the suc_inc status
    write(msg,'("INCOMPLETE profile:")');
    if(zerolines1) write(msg,'(a," zerolines1 is T")')trim(msg);
    if(cksm_bad) write(msg,'(a," cksm_bad is T")')trim(msg);
    if(maxflag==3 .or. maxflag==4)then
	JOB_STATUS = failed_incomplete_status;
	if(DEBUG) write(DBG,'("JOB_ST PROF @4 Set JOB_STATUS: ",i2," failed_incomplete_status")')JOB_STATUS
	write(msg,'(a," max flag is FAIURE.")')trim(msg);
    else
	JOB_STATUS = passed_incomplete_status;
	if(DEBUG) write(DBG,'("JOB_ST PROF @5 Set JOB_STATUS: ",i2," passed_incomplete_status")')JOB_STATUS
	write(msg,'(a," max flag is SUCCESS.")')trim(msg);
    endif
elseif(nlev==1)then
    JOB_STATUS = partially_qced_status;
    if(DEBUG) write(DBG,'("JOB_ST PROF @6 Set JOB_STATUS: ",i2," partially_qced_status")')JOB_STATUS
elseif(max_flag(p1r,deep_pres_ncol)>2)then
    JOB_STATUS = deep_pres_failed_status
    if(DEBUG) write(DBG,'("JOB_ST PROF @7 Set JOB_STATUS: ",i2," deep_pres_failed_status")')JOB_STATUS
elseif(maxflag>2)then
    JOB_STATUS = profile_failed_status;
    if(DEBUG) write(DBG,'("JOB_ST PROF @8 Set JOB_STATUS: ",i2," profile_failed_status")')JOB_STATUS
endif

!----------------------------------------------------------------------
! profile status has been determined, add this (and exit status) to the report line

! Signal any bad date/posn/land/speed
if(DBLEV==33)then
    write(msg,*)'LEV33'; call wrtdbg(prg,msg);
    write(msg,*)'LEV33  date_good: ', date_good,'  date_flag: ', date_flag; call wrtdbg(prg,msg);
    write(msg,*)'LEV33  posn_good: ', posn_good,'  posn_flag: ', posn_flag; call wrtdbg(prg,msg);
    write(msg,*)'LEV33  land_good: ', land_good,'  land_flag: ', land_flag; call wrtdbg(prg,msg);
    write(msg,*)'LEV33 speed_good: ',speed_good,' speed_flag: ',speed_flag; call wrtdbg(prg,msg);
    JOB_STATUS = 0; ! Test the pure dpls
endif

!----------------------------------------------------------------------
! Were there warnings? If so, set wrn_to_JOB_STATUS accordingly, and write smmary lines

if(nwarn > 0)then;
    wrn_to_JOB_STATUS = 100;
    call wrtlog(prg,SEPPLUS);
    do i=1,nwarn
	call wrtlog(prg,wrnmsgs(i));
    enddo
endif

!----------------------------------------------------------------------
! Were there erors? If so, set err_to_JOB_STATUS accoringly, and write summary_lines

if(nerror > 0)then; ! counter for NON-FATAL errors
    
    err_to_JOB_STATUS = 200;  ! These are NON-FATAL errors - more serious than warnings.
    call wrtlog(prg,SEPPLUS);
    do i=1,nerror
	call wrtlog(prg,errmsgs(i));
    enddo
endif
if((nwarn > 0) .or. (nerror > 0)) call wrtlog(prg,SEPPLUS);
!======================================================================
! Next, the shorthand for the instrument type, and the date/posn/land/speed chars

if(ncmeta_noprof)then;
    dpls = "____"; ! dpls is meaningless if no phy file is read
elseif(make_ncmeta .or. make_nctech .or. make_nctraj .or. make_ncbiot)then;
    dpls = "____"; ! dpls meaningless for multi-profle jobs
else;
    if(prof_JULD_QC == "1")then
	dpls(1:1) = ".";
    elseif(prof_JULD_QC == "0")then
	dpls(1:1) = "_";
    else
	dpls(1:1) = prof_JULD_QC;
    endif

    if(prof_POSITION_QC=="1")then
	dpls(2:2) = ".";
    elseif(prof_POSITION_QC=="0")then
	dpls(2:2) = "_";
    else
	dpls(2:2) = prof_POSITION_QC;
    endif
    dpls(3:3) = reppsfl(on_land_result);
    dpls(4:4) = reppsfl(speed_result);
endif

!----------------------------------------------------------------------
if(posloc > 0)then;
    write(msg,'("DPLS posloc: ",i3," posqc: ",a1," lat/lon: ",2f12.4," date: ",a," juld_loc: ",f20.12)') &
	posloc,prof_POSITION_QC,prof_LATITUDE,prof_LONGITUDE,prof_DATE_TIME_LOCATION,prof_JULD_LOCATION
    call wrtlog(prg,msg); if(DEBUG) write(DBG,'("DBG: ",a)')trim(msg); ! DBG
    write(msg,'("DPLS posloc: ",i3," ipos_dateqc: ",i3," ipos_posiqc: ",i3," ipos_onland: ",i3," ipos_speedc: ",i3," dpls: ",a)') &
	posloc, ipos_dateqc(posloc), ipos_posiqc(posloc), ipos_onland(posloc) ,ipos_speedc(posloc),dpls
    call wrtlog(prg,msg); if(DEBUG) write(DBG,'("DBG: ",a)')trim(msg); ! DBG
endif
!----------------------------------------------------------------------

! ECaluate the (add_to_)JOB_STATUS wrt the dpls
    if(dpls == '....')then; add_to_JOB_STATUS = 00; ! perfect position
elseif(dpls == '____')then; add_to_JOB_STATUS = 00; ! nonprof, dpls meaningless
elseif(dpls == '.9__')then; add_to_JOB_STATUS = 60; ! good date, position missing (999 line)
elseif(dpls == '.8..')then; add_to_JOB_STATUS = 00; ! interpolated position
elseif(dpls == '.4..')then; add_to_JOB_STATUS = 10; ! good except for bad position
elseif(dpls == '..4.')then; add_to_JOB_STATUS = 10; ! good except on_land
elseif(dpls == '...4')then; add_to_JOB_STATUS = 20; ! good except bad speed check
elseif(dpls == '.4.4')then; add_to_JOB_STATUS = 30; ! good date, not on land, posn & speed bad
elseif(dpls == '.44.')then; add_to_JOB_STATUS = 40; ! good date, speed, posn ibad & on_land
elseif(dpls == '.2..')then; add_to_JOB_STATUS = 00; ! (probably) perfect position
elseif(dpls == '.3..')then; add_to_JOB_STATUS = 10; ! good excetp for (probably) bad position
elseif(dpls == '.444')then; add_to_JOB_STATUS = 50; ! good date, bad posn/land/speed
elseif(dpls == '99__')then; add_to_JOB_STATUS = 80; ! date & poition both missing
elseif(dpls == '9.._')then; add_to_JOB_STATUS = 70; ! good position, date missing
elseif(dpls == '.9..')then; add_to_JOB_STATUS = 90; ! Should NOT occur, add a NON-FATAL error
! OLD else
! OLD     write(errmsg(2),'("NON-FATAL ERROR 206 profile: ",a)')trim(profile)
! OLD     write(errmsg(1),'("NON-FATAL ERROR 206 Value of DPLS is not recognized: ",a)')dpls
! OLD     call error_report(prg,206,2,errmsg);
endif
!----------------------------------------------------------------------
if(add_to_JOB_STATUS > 0) JOB_STATUS = JOB_STATUS + add_to_JOB_STATUS; ! dpls JOB_STATUS added
if(err_to_JOB_STATUS > 0)then;
    JOB_STATUS = JOB_STATUS + err_to_JOB_STATUS;                       ! error JOB_STATUS added
elseif(wrn_to_JOB_STATUS > 0)then;
    JOB_STATUS = JOB_STATUS + wrn_to_JOB_STATUS;                       ! or warning JOB_STATUS added endif
endif
!======================================================================

EXIT_STATUS = set_exit_status(JOB_STATUS);

!----------------------------------------------------------------------
! all of the stuff is done, creae the report line
! Start with the profile name, JOB_STATUS and EXIT_STATUS
! (MAXPROFCHR is 24 - but use an even 20 for the report line)

write(repmsg,'(a20,i3,i3)')profile,JOB_STATUS,EXIT_STATUS

!----------------------------------------------------------------------
! Next, the 8-ch shorthand for the file production

write(repmsg,'(a,2x,a)')trim(repmsg),filmsg

!----------------------------------------------------------------------
! Write the short inst_type string

write(repmsg,'(a,x,a5)')trim(repmsg),adjustl(inst_type_short)

!----------------------------------------------------------------------
! Write dpls to the report line

write(repmsg,'(a,2x,a4)')trim(repmsg),dpls

!----------------------------------------------------------------------
! After we write dpls, see if this is a case of ncmeta_noprof (ie, xxx)

if(ncmeta_noprof)then
    write(repmsg,'(a," 99999999 999 -999     0 0 0 0  ___  _________  _________ _")')trim(repmsg)
    go to 890; ! This goes directly to add_reportline
endif

!----------------------------------------------------------------------
! write date/lat/lon to the report line
if(abs(real_LATITUDE) > 99.0 .or. abs(real_LONGITUDE) > 999.9)then
    if(abs(real_LATITUDE) > 99.0)then
	write(repmsg,'(a,x,a8," 999")')trim(repmsg),prof_DATE_TIME_PROFILE(1:8)
    else
	write(repmsg,'(a,x,a8,i4)')trim(repmsg),prof_DATE_TIME_PROFILE(1:8),ifix(real_LATITUDE)
    endif
    if(abs(real_LONGITUDE) > 999.9)then
	write(repmsg,'(a,"  999")')trim(repmsg)
    else
	write(repmsg,'(a,i5)')trim(repmsg),ifix(real_LONGITUDE)
    endif
else
    write(repmsg,'(a,x,a8,i4,i5)')trim(repmsg),prof_DATE_TIME_PROFILE(1:8),ifix(real_LATITUDE),ifix(real_LONGITUDE)
endif
!----------------------------------------------------------------------
if(make_ncmeta .or. make_nctech .or. make_nctraj .or. make_ncbiot)then;
    write(repmsg,'(a,"     0 0 0 0  ___  _________  _________ _")')trim(repmsg)
    go to 890; ! This goes directly to add_reportline
endif
!----------------------------------------------------------------------
! write the nlev & overall flags to the report line
write(repmsg,'(a,x,i5,3i2)')trim(repmsg),nlev,overflag(p1r),overflag(t1r),overflag(s1r)
!----------------------------------------------------------------------
! write the flags to thr report line
write(repmsg,'(a,a2,a1)')trim(repmsg),tsp,repflag(max_flag(p1r,1));
do iflg=2,NFLAGPRES; write(repmsg,'(a,a1)')trim(repmsg),repflag(max_flag(p1r,iflg)); enddo
write(repmsg,'(a,a2,a1)')trim(repmsg),tsp,repflag(max_flag(t1r,1));
write(repmsg,'(a,a1)')trim(repmsg),repflag(max_flag(t1r,regional_ncol));        ! always add the regional flag for T
do iflg=2,NFLAGTEMP; write(repmsg,'(a,a1)')trim(repmsg),repflag(max_flag(t1r,iflg)); enddo

testch1=repindc(FROZN_T); if(temp_is_frozen .and. (frozen_profile_rule==1)) testch1 = '4'; ! Gilson rule for frozen
write(repmsg,'(a,a1,a1,a1)')trim(repmsg),repflag(STUCK_T),repflag(JUMPC_T),testch1; ! add the indicators for T
write(repmsg,'(a,a2,a1)')trim(repmsg),tsp,repflag(max_flag(s1r,1));
write(repmsg,'(a,a1)')trim(repmsg),repflag(max_flag(s1r,regional_ncol));        ! always add the regional flag for S

do iflg=2,dengrad_ncol-1;
    write(repmsg,'(a,a1)')trim(repmsg),repflag(max_flag(s1r,iflg)); 
enddo
!OLD if(NFLAGPSAL > dengrad_ncol)then; ! ask Vicki if we will need this again, dengrad_ncol is 6, NFLAGPSALis 6 (always)
!OLD     do iflg=dengrad_ncol+1,NFLAGPSAL;
!OLD 	write(repmsg,'(a,a1)')trim(repmsg),repflag(max_flag(s1r,iflg));
!OLD     enddo
!OLD endif
!----------------------------------------------------------------------

testch1=repindc(FROZN_S); if(psal_is_frozen .and. (frozen_profile_rule==1)) testch1 = '4'; ! Gilson rule for frozen
write(repmsg,'(a,a1,a1,a1)')trim(repmsg),repflag(STUCK_S),repflag(JUMPC_S),testch1; ! add the indicators for S
write(repmsg,'(a,x,a1)')trim(repmsg),repflag(max_flag(s1r,dengrad_ncol));       ! density gradient different - solo column

!----------------------------------------------------------------------
890 continue

call add_reportline('qcplus')          			                                            ! In qcplus itself, normal exit

! A last parting message
write(msg,'(a)')SEPMNUS; call wrtstd(prg,msg);
write(msg,'("Normal exit with JOB_STATUS: ",i5," EXIT_STATUS: ",i3)')JOB_STATUS,EXIT_STATUS; call wrtstd(prg,msg);

!======================================================================
! Finally, close any files left open, and exit 

call close_files()

call direct_exit(prg,EXIT_STATUS,'Normal exit');				! In qcplus, normal exit 

end program qcplus;	! TEST end		! End of program qc.f90
!======================================================================
